    ;TO DO: 
;WaveMorphSynth--add noise module? modify vibrato, instead make Pitch Bend and Mod wheels in the GUI? Rethink this configuration, add FM?, add Wave Terrain?
;(((A)))) copy all code, revise audio guts to make a VCO version
;vco2 can be saw, pulse, saw/triangle/ramp, square, integrated saw (has PW options)
;vco can be saw, square/PWM, triangle/saw/ramp
;moog is an analog model of a moog synth--seems limited relative to the vco opcodes
;(((B)))) incorporate the effects modules and MIDI automation into GranSynth
;(((C)))) consider modifying WaveMorph to just be a big Rompler and get loads of function tables that can be loaded into each oscillator
;(((D)))) maybe make a huge non-linear synth with much more RM, AM, FM controls--maybe also Wave Terrain (or make this a separate synth?)
;(((E)))) create a huge additive synth? Sort of like WaveMorph but tunable harmonics with each harmonic a separate oscillator
;consider adding a noise module to WaveMorphSynth and also to any other models


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CODE GUIDE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Cabbage code—GUI design:
    ;color macros
    ;main GUI
    ;plant code
;CSound code:
    ;headers a and initialization of global values and function tables
    ;.orc       
        ;instr 1 = basic synth
        ;instr 100 = global MIDI data gathering for instr 110-300
        ;instr 110-117 MIDI mapping for Wave 1 plant
        ;instr 120-127 MIDI mapping for Wave 2 plant
        ;instr 130-132 MIDI mapping for Waves 3 and 4 rates
        ;instr 140-150 MIDI mapping for Osc 1
        ;instr 160-170 MIDI mapping for Osc 2
        ;instr 180-190 MIDI mapping for Osc 3  
        ;instr 200-204 MIDI mapping for RNG
        ;instr 210-213 MIDI mapping for distortion
        ;instr 220-223 MIDI mapping for Vibrato
        ;instr 230-232 MIDI mapping for Lowpass filter
        ;instr 240-244 MIDI mapping for phaser
        ;instr 250-252 MIDI mapping for flanger
        ;instr 260-273 MIDI mapping for transposer
        ;instr 280-286 MIDI mapping for chorus
        ;instr 290-292 MIDI mapping for delay
        ;instr 300-303 MIDImapping for reverb
        ;instr 400-401 generate two morphing oscillators each
        ;instr 500-600 are global effects and global audio clear instruments
    ;.sco with some function table generation but mostly turning on the instruments 


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CABBAGE CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<Cabbage>

;color macros:
#define PLANT colour(76,130,180,155) outlinecolour(0,0,0,255) outlinethickness(2)
#define BASIC colour(56, 150, 180, 255) trackercolour(56,255,182,255) outlinecolour(17,37,37,155)
#define FTABLES tablegridcolour("Silver") tablecolour:0(20,20,20,245) tablebackgroundcolour("Silver")
#define BUTTONS colour:0(79,79,79,105) colour:1("Grey")
#define MIDI colour:0(96,150,170,255) colour:1("Grey") value(0) latched(0)
#define MIDIX colour:0(96,150,170,255) colour:1("red") value(0) latched(0) 
#define FONT fontcolour("Gainsboro")

;MAIN GUI:
form caption("WaveMorphSynth"), size(996, 390), pluginid("WMSyn"), colour(76,130,180,155) style("legacy") fontcolour("Gainsboro")
label bounds(2, 5, 150, 15) text("Morphing Waveforms:") fontcolour(255, 255, 255, 255)
label bounds(421, 5, 120, 15) text("Oscillators:") fontcolour(255, 255, 255, 255)
label bounds(495, 5, 100, 10) text("Presets:") fontcolour(255, 255, 255, 255)
combobox bounds(568, 2, 140, 15), channel("combobox"), populate("*.snaps")
filebutton bounds(710, 2, 40, 15), channel("preset"), text("Save"), mode("snapshot")
label bounds(738,5,100,10) text("Keyboard Scale:") fontcolour(255,255,255,255)
combobox bounds(825, 2, 70, 17), channel("MasterScale") text("Equal Temp", "1/8 Tone", "1/6 Tone", "1/4 Tone", "1/3 Tone",  "7 Tone", "8 Tone", "9 Tone", "10 Tone", "11 Tone", "13 Tone", "14 Tone", "15 Tone")
label bounds(878,5,100,10) text("Scale Start:") fontcolour(255,255,255,255)
nslider bounds(955,2,40,15) channel("ScaleStart") range(20,108,60.00,1,.01)


;label bounds(875,5,80,10) text("Active Controller:"), fontcolour(255,255,255,255)
;nslider bounds(955,2,40,15) channel("CtrlNum") range(0,127,0,1,1)
keyboard bounds(105,305,886, 80)

;PLANTS
;Function Table 1 (15 random harmonics summed)
image bounds(4, 20, 153, 182) plant("Ftable1") $PLANT
{
gentable bounds(5, 5, 143, 60) identchannel("table101") tablenumber(101.0) amprange(-1.0, 1.0, 1.0, 0.0100) outlinethickness(2) $FTABLES
label bounds(7, 68, 50, 15) text("Wave 1") $FONT
combobox bounds(85, 70, 55, 15) channel("W1basewave") identchannel("waveset"), text("Sine", "Square", "Saw", "Triangle", "Pulse")
label bounds(5, 92, 27, 10) text("Rand") $FONT
button bounds(5, 108, 25, 15) channel("W1WaveRand") text("Off", "On"), $BUTTONS
button bounds(37,89,27,15) text("Rate") channel("mapW1WRate") $MIDI
button bounds(64,89,9,15) text("") channel("mapW1WRateX") $MIDIX
button bounds(73,89,27,15) text("R Dev") channel("mapW1WRR") $MIDI
button bounds(100,89,9,15) text("") channel("mapW1WRRX") $MIDIX
button bounds(110,89,30,15) text("Smooth") channel("mapW1WSmooth") $MIDI
button bounds(140,89,9,15) text("") channel("mapW1WSmoothX") $MIDIX
rslider bounds(41, 102, 25, 25) channel("W1WRate") range(0.01, 10, 0.1, 0.75, 0.01) $BASIC
rslider bounds(77, 102, 25, 25) channel("W1WRR") range(0.01, .95, 0.1, 1, 0.01) $BASIC
rslider bounds(112, 102, 25, 25) channel("W1Wsmooth") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC
label bounds(5, 128, 95, 11) text("Random Harmonics") $FONT
button bounds(2,142,27,15) text("Rate") channel("mapW1RandRate") $MIDI
button bounds(29,142,9,15) text("") channel("mapW1RandRateX") $MIDIX
button bounds(40,142,27,15) text("R Dev") channel("mapW1RR") $MIDI
button bounds(67,142,9,15) text("") channel("mapW1RRX") $MIDIX
button bounds(76,142,27,15) text("H Dev") channel("mapW1RandDev") $MIDI
button bounds(103,142,9,15) text("") channel("mapW1RandDevX") $MIDIX
button bounds(113,142,27,15) text("Scale") channel("mapW1RandScale") $MIDI
button bounds(140,142,9,15) text("") channel("mapW1RandScaleX") $MIDIX
rslider bounds(6, 157, 25, 25) channel("W1RandRate") range(0.1, 15, .75, 0.75, 0.01) $BASIC 
rslider bounds(43, 157, 25, 25) channel("W1RR") range(0, .95, 0.2, 1, 0.01) $BASIC
rslider bounds(79, 157, 25, 25) channel("W1RandDev") range(0, 2, 0.3, 1, 0.01) $BASIC
rslider bounds(116, 157, 25, 25) channel("W1RandScale") range(0, 1, 0, 2, 0.01) $BASIC
}

;Function Table 2 (15 random harmonics summed)
image bounds(158, 20, 153, 182) plant("Ftable2") $PLANT
{
gentable bounds(5, 5, 143, 60) identchannel("table102") tablenumber(102.0) amprange(-1.0, 1.0, 1.0, 0.0100) outlinethickness(2) $FTABLES
label bounds(7, 68, 60, 15) text("Wave 2") $FONT
combobox bounds(85, 70, 55, 15) channel("W2basewave") identchannel("waveset"), text("Sine", "Square", "Saw", "Triangle", "Pulse")
label bounds(5, 90, 27, 10) text("Rand") $FONT
button bounds(5, 108, 25, 15) channel("W2WaveRand") text("Off", "On"), $BUTTONS
button bounds(37,89,27,15) text("Rate") channel("mapW2WRate") $MIDI
button bounds(64,89,9,15) text("") channel("mapW2WRateX") $MIDIX
button bounds(73,89,27,15) text("R Dev") channel("mapW2WRR") $MIDI
button bounds(100,89,9,15) text("") channel("mapW2WRRX") $MIDIX
button bounds(110,89,30,15) text("Smooth") channel("mapW2WSmooth") $MIDI
button bounds(140,89,9,15) text("") channel("mapW2WSmoothX") $MIDIX
rslider bounds(41, 102, 25, 25) channel("W2WRate") range(0.01, 10, 0.1, 0.75, 0.01) $BASIC
rslider bounds(77, 102, 25, 25) channel("W2WRR") range(0.01, .95, 0.1, 1, 0.01) $BASIC
rslider bounds(112, 102, 25, 25) channel("W2Wsmooth") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC
label bounds(5, 128, 95, 11) text("Random Harmonics") $FONT
button bounds(2,142,27,15) text("Rate") channel("mapW2RandRate") $MIDI
button bounds(29,142,9,15) text("") channel("mapW2RandRateX") $MIDIX
button bounds(40,142,27,15) text("R Dev") channel("mapW2RR") $MIDI
button bounds(67,142,9,15) text("") channel("mapW2RRX") $MIDIX
button bounds(76,142,27,15) text("H Dev") channel("mapW2RandDev") $MIDI
button bounds(103,142,9,15) text("") channel("mapW2RandDevX") $MIDIX
button bounds(113,142,27,15) text("Scale") channel("mapW2RandScale") $MIDI
button bounds(140,142,9,15) text("") channel("mapW2RandScaleX") $MIDIX
rslider bounds(6, 157, 25, 25) channel("W2RandRate") range(0.1, 15, .75, 0.75, 0.01) $BASIC 
rslider bounds(43, 157, 25, 25) channel("W2RR") range(0, .95, 0.2, 1, 0.01) $BASIC
rslider bounds(79, 157, 25, 25) channel("W2RandDev") range(0, 2, 0.3, 1, 0.01) $BASIC
rslider bounds(116, 157, 25, 25) channel("W2RandScale") range(0, 1, 0, 2, 0.01) $BASIC
}

;Function Table 3 (random cubic spline curves)
image bounds(312, 20, 150, 90) plant("Ftable3") $PLANT
{
label bounds(5, 68, 50, 15) text("Wave 3") $FONT
gentable bounds(5, 5, 140, 60) identchannel("table103") tablenumber(103.0) amprange(-1.0, 1.0, 1.0, 0.0100) outlinethickness(2) $FTABLES
;label bounds(55, 75, 35, 10) text("Rate") $FONT
button bounds(70,70,27,15) text("Rate") channel("mapW3Rate") $MIDI
button bounds(97,70,9,15) text("") channel("mapW3RateX") $MIDIX
rslider bounds(110, 64, 25, 25) channel("W3RandRate") range(0.1, 15, 1.75, 0.75, 0.01) $BASIC 
}

;Function Table 4 (random cubic spline curves)
image bounds(312, 112, 150, 90) plant("Ftable4") $PLANT
{
label bounds(5, 68, 50, 15) text("Wave 4") $FONT
gentable bounds(5, 5, 140, 60) identchannel("table104") tablenumber(104.0) amprange(-1.0, 1.0, 1.0, 0.0100) outlinethickness(2) $FTABLES)
;label bounds(55, 75, 35, 10) text("Rate") $FONT
button bounds(70,70,27,15) text("Rate") channel("mapW4Rate") $MIDI
button bounds(97,70,9,15) text("") channel("mapW4RateX") $MIDIX
rslider bounds(110, 64, 25, 25) channel("W4RandRate") range(0.1, 15, 1, 0.75, 0.01) $BASIC 
}

;OSC 1
image bounds(463, 20, 175, 182) plant("Osc 1") $PLANT
{
label bounds(45, 5, 80, 30) text("OSC 1") $FONT
button bounds(9, 11, 30, 20) channel("osc1") text("Off", "On") value(1) $BUTTONS
button bounds(130,5,27,15) text("Amp") channel("mapOsc1amp") $MIDI
button bounds(157,5,9,15) text("") channel("mapOsc1ampX") $MIDIX
rslider bounds(132, 20, 25, 25) channel("Osc1amp") range(0, 1, 0.5, 1, 0.01) $BASIC
label bounds(2, 34, 40, 10) text("Tune:") $FONT
button bounds(2,46,30,15) text("Coarse") channel("mapOsc1Tcoarse") $MIDI
button bounds(32,46,9,15) text("") channel("mapOsc1TcoarseX") $MIDIX
button bounds(43,46,27,15) text("Fine") channel("mapOsc1Tfine") $MIDI
button bounds(70,46,9,15) text("") channel("mapOsc1TfineX") $MIDIX
rslider bounds(5, 62, 25, 25) channel("Osc1Tcoarse") range(-24, 24, 0, 1, 1) $BASIC
rslider bounds(35, 62, 25, 25) channel("Osc1Tfine") range(-1, 1, 0, 1, 0.01) $BASIC
label bounds(75,48,40,10) text("Wave") $FONT
combobox bounds(67,65,50,17) channel("Osc1fn") text("Wave 1", "Wave 2", "Wave 3", "Wave 4")
label bounds(115,48,60,10) text("Bend Range") $FONT
label bounds(113,64,30,10) text("up") $FONT
label bounds(113,80,30,10) text("down") $FONT
nslider bounds(140,62,35,15) channel("Osc1BendUp") range(-24,24,2,1,.01)
nslider bounds(140,78,35,15) channel("Osc1BendDown") range(-24,24,2,1,.01)
button bounds(5,95,17,15) text("A") channel("mapOsc1attack") $MIDI
button bounds(22,95,9,15) text("") channel("mapOsc1attackX") $MIDIX
button bounds(33,95,17,15) text("D") channel("mapOsc1decay") $MIDI
button bounds(50,95,9,15) text("") channel("mapOsc1decayX") $MIDIX
button bounds(61,95,17,15) text("S") channel("mapOsc1sustain") $MIDI
button bounds(78,95,9,15) text("") channel("mapOsc1sustainX") $MIDIX
button bounds(89,95,17,15) text("R") channel("mapOsc1release") $MIDI
button bounds(106,95,9,15) text("") channel("mapOsc1releaseX") $MIDIX
button bounds(130,95,27,15) text("Pan") channel("mappan1") $MIDI
button bounds(157,95,9,15) text("") channel("mappan1X") $MIDIX
rslider bounds(132, 110, 25, 25) channel("pan1") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(2, 110, 25, 25) channel("Osc1attack") range(0.001, 5, 0.01, 0.75, 0.001) $BASIC
rslider bounds(30, 110, 25, 25) channel("Osc1decay") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC 
rslider bounds(58, 110, 25, 25) channel("Osc1sustain") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(86, 110, 25, 25) channel("Osc1release") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC 
label bounds(8,140,35,10) text("RM") $FONT
combobox bounds(5,155,50,17) channel("RMselect1") text("none", "Wave 1", "Wave 2", "Wave 3", "Wave 4", "Sine", "Square")
button bounds(48,137,35,15) text("RM Ratio") channel("mapRMratio1") $MIDI
button bounds(83,137,9,15) text("") channel("mapRMratio1X") $MIDIX
rslider bounds(58, 153, 25, 25) channel("RMratio1") range(.01, 5, 1, 0.5, 0.01) $BASIC 
button bounds(94,137,27,15) text("PW") channel("mapPW1") $MIDI
button bounds(121,137,9,15) text("") channel("mapPW1X") $MIDIX
rslider bounds(94, 153, 25, 25) channel("Osc1PW") range(1, 10, 1, 0.5, 0.001) $BASIC 
}

;OSC 2
image bounds(641, 20, 175, 182) plant("Osc 2") $PLANT
{
label bounds(45, 5, 80, 30) text("OSC 2") $FONT
button bounds(9, 11, 30, 20) channel("osc2") text("Off", "On") value(1) $BUTTONS
button bounds(130,5,27,15) text("Amp") channel("mapOsc2amp") $MIDI
button bounds(157,5,9,15) text("") channel("mapOsc2ampX") $MIDIX
rslider bounds(132, 20, 25, 25) channel("Osc2amp") range(0, 1, 0.5, 1, 0.01) $BASIC
label bounds(2, 34, 40, 10) text("Tune:") $FONT
button bounds(2,46,30,15) text("Coarse") channel("mapOsc2Tcoarse") $MIDI
button bounds(32,46,9,15) text("") channel("mapOsc2TcoarseX") $MIDIX
button bounds(43,46,27,15) text("Fine") channel("mapOsc2Tfine") $MIDI
button bounds(70,46,9,15) text("") channel("mapOsc2TfineX") $MIDIX
rslider bounds(5, 62, 25, 25) channel("Osc2Tcoarse") range(-24, 24, 0, 1, 1) $BASIC
rslider bounds(35, 62, 25, 25) channel("Osc2Tfine") range(-1, 1, 0, 1, 0.01) $BASIC
label bounds(75,48,40,10) text("Wave") $FONT
combobox bounds(67,65,50,17) channel("Osc2fn") text("Wave 1", "Wave 2", "Wave 3", "Wave 4")
label bounds(115,48,60,10) text("Bend Range") $FONT
label bounds(113,64,30,10) text("up") $FONT
label bounds(113,80,30,10) text("down") $FONT
nslider bounds(140,62,35,15) channel("Osc2BendUp") range(-24,24,2,1,.01)
nslider bounds(140,78,35,15) channel("Osc2BendDown") range(-24,24,2,1,.01)
button bounds(5,95,17,15) text("A") channel("mapOsc2attack") $MIDI
button bounds(22,95,9,15) text("") channel("mapOsc2attackX") $MIDIX
button bounds(33,95,17,15) text("D") channel("mapOsc2decay") $MIDI
button bounds(50,95,9,15) text("") channel("mapOsc2decayX") $MIDIX
button bounds(61,95,17,15) text("S") channel("mapOsc2sustain") $MIDI
button bounds(78,95,9,15) text("") channel("mapOsc2sustainX") $MIDIX
button bounds(89,95,17,15) text("R") channel("mapOsc2release") $MIDI
button bounds(106,95,9,15) text("") channel("mapOsc2releaseX") $MIDIX
button bounds(130,95,27,15) text("Pan") channel("mappan2") $MIDI
button bounds(157,95,9,15) text("") channel("mappan2X") $MIDIX
rslider bounds(132, 110, 25, 25) channel("pan2") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(2, 110, 25, 25) channel("Osc2attack") range(0.001, 5, 0.01, 0.75, 0.001) $BASIC
rslider bounds(30, 110, 25, 25) channel("Osc2decay") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC 
rslider bounds(58, 110, 25, 25) channel("Osc2sustain") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(86, 110, 25, 25) channel("Osc2release") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC 
label bounds(8,140,35,10) text("RM") $FONT
combobox bounds(5,155,50,17) channel("RMselect2") text("none", "Wave 1", "Wave 2", "Wave 3", "Wave 4", "Sine", "Square")
button bounds(48,137,35,15) text("RM Ratio") channel("mapRMratio2") $MIDI
button bounds(83,137,9,15) text("") channel("mapRMratio2X") $MIDIX
rslider bounds(58, 153, 25, 25) channel("RMratio2") range(.01, 5, 1, 0.5, 0.01) $BASIC 
button bounds(94,137,27,15) text("PW") channel("mapPW2") $MIDI
button bounds(121,137,9,15) text("") channel("mapPW2X") $MIDIX
rslider bounds(94, 153, 25, 25) channel("Osc2PW") range(1, 10, 1, 0.5, 0.001) $BASIC 
label bounds(125, 140, 40, 10) text("Sync") $FONT
button bounds(138,155,15,15) channel("O2sync") text("", "") $BUTTONS
}

;OSC 3
image bounds(818, 20, 175, 182) plant("Osc 3") $PLANT
{
label bounds(45, 5, 80, 30) text("OSC 3") $FONT
button bounds(9, 11, 30, 20) channel("osc3") text("Off", "On") value(1) $BUTTONS
button bounds(130,5,27,15) text("Amp") channel("mapOsc3amp") $MIDI
button bounds(157,5,9,15) text("") channel("mapOsc3ampX") $MIDIX
rslider bounds(132, 20, 25, 25) channel("Osc3amp") range(0, 1, 0.5, 1, 0.01) $BASIC
label bounds(2, 34, 40, 10) text("Tune:") $FONT
button bounds(2,46,30,15) text("Coarse") channel("mapOsc3Tcoarse") $MIDI
button bounds(32,46,9,15) text("") channel("mapOsc3TcoarseX") $MIDIX
button bounds(43,46,27,15) text("Fine") channel("mapOsc3Tfine") $MIDI
button bounds(70,46,9,15) text("") channel("mapOsc3TfineX") $MIDIX
rslider bounds(5, 62, 25, 25) channel("Osc3Tcoarse") range(-24, 24, 0, 1, 1) $BASIC
rslider bounds(35, 62, 25, 25) channel("Osc3Tfine") range(-1, 1, 0, 1, 0.01) $BASIC
label bounds(75,48,40,10) text("Wave") $FONT
combobox bounds(67,65,50,17) channel("Osc3fn") text("Wave 1", "Wave 2", "Wave 3", "Wave 4")
label bounds(115,48,60,10) text("Bend Range") $FONT
label bounds(113,64,30,10) text("up") $FONT
label bounds(113,80,30,10) text("down") $FONT
nslider bounds(140,62,35,15) channel("Osc3BendUp") range(-24,24,2,1,.01)
nslider bounds(140,78,35,15) channel("Osc3BendDown") range(-24,24,2,1,.01)
button bounds(5,95,17,15) text("A") channel("mapOsc3attack") $MIDI
button bounds(22,95,9,15) text("") channel("mapOsc3attackX") $MIDIX
button bounds(33,95,17,15) text("D") channel("mapOsc3decay") $MIDI
button bounds(50,95,9,15) text("") channel("mapOsc3decayX") $MIDIX
button bounds(61,95,17,15) text("S") channel("mapOsc3sustain") $MIDI
button bounds(78,95,9,15) text("") channel("mapOsc3sustainX") $MIDIX
button bounds(89,95,17,15) text("R") channel("mapOsc3release") $MIDI
button bounds(106,95,9,15) text("") channel("mapOsc3releaseX") $MIDIX
button bounds(130,95,27,15) text("Pan") channel("mappan3") $MIDI
button bounds(157,95,9,15) text("") channel("mappan3X") $MIDIX
rslider bounds(132, 110, 25, 25) channel("pan3") range(0, 1, .5, 1, 0.01) $BASIC 
rslider bounds(2, 110, 25, 25) channel("Osc3attack") range(0.001, 5, 0.01, 0.75, 0.001) $BASIC
rslider bounds(30, 110, 25, 25) channel("Osc3decay") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC 
rslider bounds(58, 110, 25, 25) channel("Osc3sustain") range(0, 1, 0.85, 1, 0.01) $BASIC 
rslider bounds(86, 110, 25, 25) channel("Osc3release") range(0.01, 5, 0.1, 0.75, 0.01) $BASIC 
label bounds(8,140,35,10) text("RM") $FONT
combobox bounds(5,155,50,17) channel("RMselect3") text("none", "Wave 1", "Wave 2", "Wave 3", "Wave 4", "Sine", "Square")
button bounds(48,137,35,15) text("RM Ratio") channel("mapRMratio3") $MIDI
button bounds(83,137,9,15) text("") channel("mapRMratio3X") $MIDIX
rslider bounds(58, 153, 25, 25) channel("RMratio3") range(.01, 5, 1, 0.5, 0.01) $BASIC 
button bounds(94,137,27,15) text("PW") channel("mapPW3") $MIDI
button bounds(121,137,9,15) text("") channel("mapPW3X") $MIDIX
rslider bounds(94, 153, 25, 25) channel("Osc3PW") range(1, 10, 1, 0.5, 0.001) $BASIC 
label bounds(125, 140, 40, 10) text("Sync") $FONT
button bounds(138,155,15,15) channel("O3sync") text("", "") $BUTTONS
}

;FX plants:


;Vibrato (LFO Modulation, controller 1)
image bounds(4,204,98,183) plant("Vib") $PLANT
{
label bounds(0,2,40,10) text("Vibrato") $FONT
button bounds(48,3,27,15) text("R Dev") channel("mapvibrand") $MIDI
button bounds(75,3,9,15) text("") channel("mapvibrandX") $MIDIX
rslider bounds(52,18,25,25) channel("vibrand") range(0, .99, 0.05, .5, 0.001) $BASIC
button bounds(10,158,27,15) text("Rate") channel("mapvibcps") $MIDI
button bounds(37,158,9,15) text("") channel("mapvibcpsX") $MIDIX
;rslider bounds(9,52,25,25) channel("vibcps") range(0, 1, 0, .5, .01) $BASIC
vslider bounds(15,55,25,105) channel("vibcps") range(0, 1, 0, .5, .01) $BASIC
button bounds(58,158,27,15) text("Depth") channel("mapvibdepth") $MIDI
button bounds(85,158,9,15) text("") channel("mapvibdepthX") $MIDIX
;rslider bounds(76,52,25,25) channel("vibdepth") range(0, 1, 1, .5, 0.01) $BASIC
vslider bounds(60,55,25,105) channel("vibdepth") range(0, 1, 1, .5, 0.01) $BASIC
label bounds(3,30,25,10) text("max:") fontcolour(255,255,255,255)
nslider bounds(3,40,45,15) channel("vibcpsmax") range(0,2500,6,1,.01)
nslider bounds(50,40,45,15) channel("vibdepthmax") range(0,48,.15,1,.01)
}

;Random Note Generator
image bounds(104,204,153,98) plant("Random Note Generator") $PLANT
{
label bounds(2, 2, 115, 10) text("Random Note Generator") $FONT
button bounds(5, 16, 30, 17), channel("RNGon") text("Off", "On") value(0) $BUTTONS
combobox bounds(38, 16, 70, 17), channel("RNGmicro") text("Equal Temp", "Microtonal", "1/4 Tone", "1/8 Tone", "Whole Tone", "Minor 3rds", "Major 3rds", "4ths", "Tritones", "5ths", "10 Tone", "13 Tone", "15 Tone", "7 Tone", "8 Tone")
button bounds(110, 16, 39, 17), channel("RNGgliss") text("Hold", "Gliss") value(0) $BUTTONS
button bounds(3,40,27,15) text("Rate") channel("mapRNGrate") $MIDI
button bounds(30,40,9,15) text("") channel("mapRNGrateX") $MIDIX
button bounds(40,40,27,15) text("R Dev") channel("mapRNGraterand") $MIDI
button bounds(67,40,9,15) text("") channel("mapRNGraterandX") $MIDIX
button bounds(77,40,27,15) text("A Dev") channel("mapRNGamprand") $MIDI
button bounds(104,40,9,15) text("") channel("mapRNGamprandX") $MIDIX
button bounds(114,40,27,15) text("F Dev") channel("mapRNGdev") $MIDI
button bounds(141,40,9,15) text("") channel("mapRNGdevX") $MIDIX
rslider bounds(5, 57, 25, 25) channel("RNGrate") range(0.01, 100, 3.3, .5, 0.01) $BASIC
rslider bounds(40, 57, 25, 25) channel("RNGraterand") range(0, .95, 0, 1, 0.01) $BASIC
rslider bounds(80, 57, 25, 25) channel("RNGamprand") range(0, .95, 0, 1, 0.01) $BASIC
rslider bounds(120, 57, 25, 25) channel("RNGdev") range(0, 60, 6, 1, 0.01) $BASIC
}

;Distortion
image bounds(259,204,70,98) plant("Distort") $PLANT
{
label bounds(2, 2, 35, 10) text("Distort") $FONT
button bounds(7,23,27,15) text("Dist") channel("mapdist") $MIDI
button bounds(34,23,9,15) text("") channel("mapdistX") $MIDIX
button bounds(4,46,30,15) text("Shape") channel("mapdist2") $MIDI
button bounds(34,46,9,15) text("") channel("mapdist2X") $MIDIX
button bounds(7,69,27,15) text("Fold") channel("mapdist3") $MIDI
button bounds(34,69,9,15) text("") channel("mapdist3X") $MIDIX
rslider bounds(44, 18, 25, 25) channel("dist") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(44, 41, 25, 25) channel("dist2") range(0, .999, 0, 1, 0.001) $BASIC 
rslider bounds(44, 64, 25, 25) channel("dist3") range(1, 25, 1, .5, 0.001) $BASIC 
}

;Lowpass Moog ladder filter
image bounds(331,204,50,98) plant("LP") $PLANT
{
label bounds(2,2,40,10) text("Lowpass") $FONT
button bounds(7,19,27,15) text("Cutoff") channel("mapLPcps") $MIDI
button bounds(34,19,9,15) text("") channel("mapLPcpsX") $MIDIX
rslider bounds(12,32,25,25) channel("LPcps") range(100, 15000, 7500, 0.25, 10) $BASIC
button bounds(7,55,27,15) text("Res") channel("mapLPres") $MIDI
button bounds(34,55,9,15) text("") channel("mapLPresX") $MIDIX
rslider bounds(12,68,25,25) channel("LPres") range(0.01, .99, 0.1, 1, 0.01) $BASIC
}

;phaser
image bounds(383,204,72,98) plant("Phaser") $PLANT
{
button bounds(5,2,40,15) channel("phson") text("Phaser", "Phaser") $BUTTONS
button bounds(7,23,27,15) text("Speed") channel("mapphscps") $MIDI
button bounds(34,23,9,15) text("") channel("mapphscpsX") $MIDIX
rslider bounds(44,18,25,25) channel("phscps") range(0.01, 100, .4, 0.25, 0.01) $BASIC
button bounds(7,46,27,15) text("FB") channel("mapphsFB") $MIDI
button bounds(34,46,9,15) text("") channel("mapphsFBX") $MIDIX
rslider bounds(44,41,25,25) channel("phsFB") range(0, 1, 0.5, 1, 0.01) $BASIC
button bounds(7,69,27,15) text("Q") channel("mapphsQ") $MIDI
button bounds(34,69,9,15) text("") channel("mapphsQX") $MIDIX
rslider bounds(44,64,25,25) channel("phsQ") range(0.01, 100, 1, .25, 0.01) $BASIC
}

;flanger
image bounds(457,204,50,98) plant("Flanger") $PLANT
{
button bounds(5,2,40,15) channel("flon") text("Flanger", "Flanger") $BUTTONS
button bounds(8,19,27,15) text("Speed") channel("mapflcps") $MIDI
button bounds(35,19,9,15) text("") channel("mapflcpsX") $MIDIX
rslider bounds(13,32,25,25) channel("flcps") range(0.01, 100, .05, 0.25, 0.01) $BASIC
button bounds(8,55,27,15) text("FB") channel("mapflFB") $MIDI
button bounds(35,55,9,15) text("") channel("mapflFBX") $MIDIX
rslider bounds(13,68,25,25) channel("flFB") range(0, .99, 0.5, 1, 0.01) $BASIC
}

;Transposer/Harmonizer
image bounds(509,204,233,98) plant("Transposer") $PLANT
{
label bounds(2, 2, 55, 10) text("Transposer") $FONT
button bounds(125,3,27,12) text("Mix") channel("mapharmmix") $MIDI
button bounds(152,3,9,12) text("") channel("mapharmmixX") $MIDIX
rslider bounds(95, 0, 25, 25) channel("harmmix") range(0, 1, 0, 1, 0.01) $BASIC 
button bounds(3,15,18,13) channel("harmon1") text("Off", "On") $BUTTONS
button bounds(3,27,27,13) text("Coarse") channel("mapharmon1C") $MIDI
button bounds(30,27,9,13) text("") channel("mapharmon1CX") $MIDIX
rslider bounds(6, 38, 25, 25) channel("harmon1C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(5,62,27,13) text("Fine") channel("mapharmon1F") $MIDI
button bounds(32,62,9,13) text("") channel("mapharmon1FX") $MIDIX
rslider bounds(6, 73, 25, 25) channel("harmon1F") range(-1, 1, .14, 1, 0.01) $BASIC
button bounds(41,15,18,13) channel("harmon2") text("Off", "On") $BUTTONS
button bounds(41,27,27,13) text("Coarse") channel("mapharmon2C") $MIDI
button bounds(68,27,9,13) text("") channel("mapharmon2CX") $MIDIX
rslider bounds(44, 38, 25, 25) channel("harmon2C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(41,62,27,13) text("Fine") channel("mapharmon2F") $MIDI
button bounds(68,62,9,13) text("") channel("mapharmon2FX") $MIDIX
rslider bounds(44, 73, 25, 25) channel("harmon2F") range(-1, 1, 0-.16, 1, 0.01) $BASIC
button bounds(79,15,18,13) channel("harmon3") text("Off", "On") $BUTTONS
button bounds(79,27,27,13) text("Coarse") channel("mapharmon3C") $MIDI
button bounds(106,27,9,13) text("") channel("mapharmon3CX") $MIDIX
rslider bounds(82, 38, 25, 25) channel("harmon3C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(79,62,27,13) text("Fine") channel("mapharmon3F") $MIDI
button bounds(106,62,9,13) text("") channel("mapharmon3FX") $MIDIX
rslider bounds(82, 73, 25, 25) channel("harmon3F") range(-1, 1, .09, 1, 0.01) $BASIC
button bounds(117,15,18,13) channel("harmon4") text("Off", "On") $BUTTONS
button bounds(117,27,27,13) text("Coarse") channel("mapharmon4C") $MIDI
button bounds(144,27,9,13) text("") channel("mapharmon4CX") $MIDIX
rslider bounds(120, 38, 25, 25) channel("harmon4C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(117,62,27,13) text("Fine") channel("mapharmon4F") $MIDI
button bounds(144,62,9,13) text("") channel("mapharmon4FX") $MIDIX
rslider bounds(120, 73, 25, 25) channel("harmon4F") range(-1, 1, 0-.12, 1, 0.01) $BASIC
button bounds(155,15,18,13) channel("harmon5") text("Off", "On") $BUTTONS
button bounds(155,27,27,13) text("Coarse") channel("mapharmon5C") $MIDI
button bounds(182,27,9,13) text("") channel("mapharmon5CX") $MIDIX
rslider bounds(158, 38, 25, 25) channel("harmon5C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(155,62,27,13) text("Fine") channel("mapharmon5F") $MIDI
button bounds(182,62,9,13) text("") channel("mapharmon5FX") $MIDIX
rslider bounds(158, 73, 25, 25) channel("harmon5F") range(-1, 1, 0.11, 1, 0.01) $BASIC
button bounds(193,15,18,13) channel("harmon6") text("Off", "On") $BUTTONS
button bounds(193,27,27,13) text("Coarse") channel("mapharmon6C") $MIDI
button bounds(220,27,9,13) text("") channel("mapharmon6CX") $MIDIX
rslider bounds(196, 38, 25, 25) channel("harmon6C") range(-24, 24, 0, 1, 1) $BASIC
button bounds(193,62,27,13) text("Fine") channel("mapharmon6F") $MIDI
button bounds(220,62,9,13) text("") channel("mapharmon6FX") $MIDIX
rslider bounds(196, 73, 25, 25) channel("harmon6F") range(-1, 1, -.05, 1, 0.01) $BASIC
}

;Chorus
image bounds(744,204,123,98) plant("Chorus") $PLANT
{
label bounds(2, 2, 35, 10) text("Chorus") $FONT
button bounds(5,19,27,15) text("Mix") channel("mapchmix") $MIDI
button bounds(32,19,9,15) text("") channel("mapchmixX") $MIDIX
button bounds(44,19,27,15) text("Rate") channel("mapchcps") $MIDI
button bounds(71,19,9,15) text("") channel("mapchcpsX") $MIDIX
button bounds(83,19,27,15) text("FB") channel("mapchFB") $MIDI
button bounds(110,19,9,15) text("") channel("mapchFBX") $MIDIX
rslider bounds(9, 32, 25, 25) channel("chmix") range(0, 1, 0, 1, 0.01) $BASIC 
rslider bounds(48, 32, 25, 25) channel("chcps") range(.01, 25, .5, .5, 0.001) $BASIC 
rslider bounds(87, 32, 25, 25) channel("chFB") range(0, .999, .7, 1, 0.001) $BASIC 
button bounds(5,55,27,15) text("Depth") channel("mapchdepth") $MIDI
button bounds(32,55,9,15) text("") channel("mapchdepthX") $MIDIX
button bounds(43,55,27,15) text("Delay") channel("mapchdel") $MIDI
button bounds(71,55,9,15) text("") channel("mapchdelX") $MIDIX
button bounds(83,55,27,15) text("Rand") channel("mapchrand") $MIDI
button bounds(110,55,9,15) text("") channel("mapchrandX") $MIDIX
rslider bounds(9, 68, 25, 25) channel("chdepth") range(.1, 50, 1.5, .5, 0.01) $BASIC 
rslider bounds(48, 68, 25, 25) channel("chdel") range(.1, 50, 15, 1, 0.01) $BASIC 
rslider bounds(87, 68, 25, 25) channel("chrand") range(0, .9, .1, .5, 0.001) $BASIC 
}

;delay
image bounds(869,204,50,98) plant("Delay") $PLANT
{
label bounds(2,2,30,10) text("Delay") $FONT
button bounds(7,19,27,15) text("Time") channel("mapdeltime") $MIDI
button bounds(34,19,9,15) text("") channel("mapdeltimeX") $MIDIX
rslider bounds(12,32,25,25) channel("deltime") range(0.001, 4.99, .08, 0.25, 0.0001) $BASIC
button bounds(7,55,27,15) text("FB") channel("mapdelFB") $MIDI
button bounds(34,55,9,15) text("") channel("mapdelFBX") $MIDIX
rslider bounds(12,68,25,25) channel("delFB") range(0, .99, 0, 1, 0.01) $BASIC
}

;reverbsc
image bounds(921,204,72,98) plant("Reverb") $PLANT
{
label bounds(2,2,40,10) text("Reverb") $FONT
button bounds(5,23,30,15) text("Mix") channel("maprevmix") $MIDI
button bounds(35,23,9,15) text("") channel("maprevmixX") $MIDIX
rslider bounds(44,18,25,25) channel("revmix") range(0,1, 0, 1, 0.01) $BASIC
button bounds(5,46,30,15) text("Decay") channel("maprevFB") $MIDI
button bounds(35,46,9,15) text("") channel("maprevFBX") $MIDIX
rslider bounds(44,41,25,25) channel("revFB") range(0.01,0.999, .6, 1.75, 0.001) $BASIC
button bounds(5,69,30,15) text("LP") channel("maprevLP") $MIDI
button bounds(35,69,9,15) text("") channel("maprevLPX") $MIDIX
rslider bounds(44,64,25,25) channel("revLP") range(200, 20000, 12500, .5, 10) $BASIC
}

</Cabbage>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;; CSOUND CODE ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
<CsoundSynthesizer>
<CsOptions>
-n -d -+rtmidi=NULL -M0 -m0d --midi-key=4 --midi-velocity-amp=5 ;sends MIDI note number and velocity to instr 1 as p4 and p5 respectively
</CsOptions>
<CsInstruments>

; Initialize the global variables. 
ksmps = 100
nchnls = 2
0dbfs = 1

gaSynL init 0   ;global synth sends to effects, need global to send all instances of instr 1 to FX
gaSynR init 0
gaChorL init 0  ;global audio for chorus effect
gaChorR init 0
gaDelL init 0   ;global feedback delay lines sends to reverb
gaDelR init 0
gaFXL init 0    ;send to global reverb and audio outs
gaFXR init 0

;Morphing Function 1 generic sine creates function table that is generated and morphed--15 harmonics
giwave101	ftgen	101,0, 8192, 10,1 
;Morphing Function 2 separately controlled from 1--10 harmonics
giwave102	ftgen	102,0, 8192, 10,1
;Morphing Function 3 16 random cubic splines
giwave103	ftgen	103,0, 8192, 8, 0, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512,rnd(2)-1, 512, 0
;Morphing Function 3 8 random cubic splines
giwave104	ftgen	104,0, 8192, 8, 0, 512,rnd(2)-1, 1024,rnd(2)-1, 1024,rnd(2)-1, 1024,rnd(2)-1, 1024,rnd(2)-1, 1024,rnd(2)-1, 1024,rnd(2)-1, 1024,rnd(2)-1,512,0

gkstatus init 0 ;initialize global MIDI settings
gkchan init 0
gkdata1 init 0
gkdata2 init 0

instr	1

;pitch bend controller
kOsc1up chnget "Osc1BendUp"
kOsc1down chnget "Osc1BendDown"
kOsc2up chnget "Osc2BendUp"
kOsc2down chnget "Osc2BendDown"
kOsc3up chnget "Osc3BendUp"
kOsc3down chnget "Osc3BendDown"
kbend pchbend 0,1   ;default set at 1 semitones up and down, can modify for each oscillator (before converting MIDI to cps)

kss chnget "ScaleStart" ;MIDI pitch number from which any selected scale is calculated
kscale chnget "MasterScale"
if kscale == 1 then 
ksc=1 ;12 tone scale
goto RNG
elseif kscale == 2 then
ksc=.25 ;1/8 tones
goto RNG
elseif kscale == 3 then
ksc=.33333 ;1/6 tones
goto RNG
elseif kscale == 4 then
ksc=.5 ;1/4 tones
goto RNG
elseif kscale == 5 then
ksc=.66666 ;1/3 tones
goto RNG
elseif kscale == 6 then
ksc=1.714 ;7 tone octave
goto RNG
elseif kscale == 7 then
ksc=1.5 ;8 tone
goto RNG
elseif kscale == 8 then
ksc=1.3333 ;9 tone
goto RNG
elseif kscale == 9 then
ksc=1.2 ;10 tone
goto RNG
elseif kscale == 10 then
ksc=1.09091 ;11 tone
goto RNG
elseif kscale == 11 then
ksc=.9231 ;13 tone
goto RNG
elseif kscale == 12 then
ksc=.85714 ;14 tone
goto RNG
elseif kscale == 13 then
ksc=.8 ;15 tone
endif

;Random Note Stream Generation
RNG:
kRNGon chnget "RNGon"
kRNGcps chnget "RNGrate"
kRNGcpsrand chnget "RNGraterand"
kRNGdev chnget "RNGdev"
kmicro chnget "RNGmicro"
kgliss chnget "RNGgliss"
kRNGamp chnget "RNGamprand"

if kRNGon == 0 then
kRNGnote=0
goto OSC1
endif

krateA randh (kRNGcps*kRNGcpsrand),kRNGcps,2 ;seed > 1 = random seeded by the system clock
knoterate=kRNGcps+krateA   ;sets master rate
if kgliss == 1 then
kRNGnote randi kRNGdev,knoterate
else
kRNGnote randh kRNGdev,knoterate
endif

if kmicro == 1 then
kRNGnote=int(kRNGnote) ;12 tone scale
goto OSC1
elseif kmicro == 2 then ;all possible frequencies
goto OSC1
elseif kmicro == 3 then
kRNGnote=(int(kRNGnote*2)*.5) ;1/4 tones
goto OSC1
elseif kmicro == 4 then
kRNGnote=(int(kRNGnote*4)*.25) ;1/8 tones
goto OSC1
elseif kmicro == 5 then
kRNGnote=int(kRNGnote)*2 ;Whole tone
goto OSC1
elseif kmicro == 6 then
kRNGnote=int(kRNGnote)*3 ;minor 3rds
goto OSC1
elseif kmicro == 7 then
kRNGnote=int(kRNGnote)*4 ;major 3rds
goto OSC1
elseif kmicro == 8 then
kRNGnote=int(kRNGnote)*5 ;4ths
goto OSC1
elseif kmicro == 9 then
kRNGnote=int(kRNGnote)*6 ;tritones
goto OSC1
elseif kmicro == 10 then
kRNGnote=int(kRNGnote)*7 ;5ths
goto OSC1
elseif kmicro == 11 then
kRNGnote=int(kRNGnote)*1.2 ;10 tone scale
goto OSC1
elseif kmicro == 12 then
kRNGnote=int(kRNGnote)*.923 ;13 tone scale
goto OSC1
elseif kmicro == 13 then
kRNGnote=int(kRNGnote)*.8 ;15 tone scale
goto OSC1
elseif kmicro == 14 then
kRNGnote=int(kRNGnote)*1.715 ;7 tone scale
goto OSC1
elseif kmicro == 15 then
kRNGnote=int(kRNGnote)*1.5 ;8 tone scale
endif

kRNGamprand randh (kRNGamp*p5),knoterate

OSC1:
;OSCILLATOR 1 DEFINED IN THIS LARGE SECTION
;;get GUI data
kosc1on chnget "osc1"
kosc1amp port kosc1on,.03
kosc1level chnget "Osc1amp"
iattack1 chnget "Osc1attack"  ;need to make sure the chnget info is specific to each oscillator so need to rename from here on down
idecay1 chnget "Osc1decay"
isustain1 chnget "Osc1sustain"
irelease1 chnget "Osc1release"
kPW1 chnget "Osc1PW"
kcoarse1 chnget "Osc1Tcoarse"
kfine1 chnget "Osc1Tfine"
kfn1 chnget "Osc1fn"
krm1 chnget "RMselect1"
krmratio1 chnget "RMratio1"
kpan1 chnget "pan1"

;calculate cps
if kbend >= 0 then 
kbend1=kbend*kOsc1up
else
kbend1=kbend*kOsc1down
endif

;calculate vibrato
kvibdepth chnget "vibdepth"
kvibdepthmax chnget "vibdepthmax"
kvibcps chnget "vibcps"
kvibcpsmax chnget "vibcpsmax"
kvibrand chnget "vibrand"
kvcps randomi kvibcpsmax-(kvibcpsmax*kvibrand),kvibcpsmax+(kvibcpsmax*kvibrand),kvibcpsmax
kvamp randomi kvibdepthmax-(kvibdepthmax*kvibrand),kvibdepthmax+(kvibdepthmax*kvibrand),kvcps
kvib oscili kvamp*kvibdepth,kvcps*kvibcps,25
if kvibcps=0 then
 kvib=0
endif

kcps11=cpsmidinn(kss+((p4-kss)*ksc)+kvib+kbend1+kfine1+kcoarse1+kRNGnote)
kcps12=kcps11*krmratio1

kenv1 madsr iattack1,idecay1,isustain1,irelease1

;add jitter
kcpsjit1 jitter .001*kcps11,.5,15
asyncinit=0
aindex1a,async1out syncphasor kcps11+kcpsjit1,asyncinit ;this provides master sync so Osc 2&3 can hard sync to Osc 1
aindex1b    phasor  kcps12

;oscillator function select logic
if kfn1==1 then
aosc1	tablei	aindex1a*kPW1,101,1
elseif kfn1==2 then
aosc1	tablei	aindex1a*kPW1,102,1
elseif kfn1==3 then
aosc1	tablei	aindex1a*kPW1,103,1
elseif kfn1==4 then
aosc1	tablei	aindex1a*kPW1,104,1
endif
;oscillator RM logic
if krm1==2 then
aosc1RM	tablei	aindex1b*kPW1,101,1
elseif krm1==3 then
aosc1RM	tablei	aindex1b*kPW1,102,1
elseif krm1==4 then
aosc1RM	tablei	aindex1b*kPW1,103,1
elseif krm1==5 then
aosc1RM	tablei	aindex1b*kPW1,104,1
elseif krm1==6 then
aosc1RM	tablei	aindex1b*kPW1,25,1
elseif krm1==7 then
aosc1RM	tablei	aindex1b*kPW1,28,1
elseif krm1==1 then
goto noRM1 ;skip over RM operation if no RM selected
endif
;RM
aosc1=aosc1*aosc1RM

noRM1:

aoscmaster1=aosc1*kosc1amp*kosc1level*kenv1*.3 ;just used for balance below, not for output

a11 balance aosc1,aoscmaster1  ;(aoscmaster1*.05)+aoscharm
a11=a11*p5
a12 delay1 a11
a11=(a11+a12)*.5   ;simple LP filter with Nyquist cutoff
a1L=a11*(1-kpan1)
a1R=a11*kpan1

;OSCILLATOR 2 DEFINED IN THIS LARGE SECTION
;;get GUI data
kosc2on chnget "osc2"
kosc2amp port kosc2on,.03
kosc2level chnget "Osc2amp"
iattack2 chnget "Osc2attack"
idecay2 chnget "Osc2decay"
isustain2 chnget "Osc2sustain"
irelease2 chnget "Osc2release"
kPW2 chnget "Osc2PW"
kcoarse2 chnget "Osc2Tcoarse"
kfine2 chnget "Osc2Tfine"
kfn2 chnget "Osc2fn"
krm2 chnget "RMselect2"
krmratio2 chnget "RMratio2"
kpan2 chnget "pan2"
ksync2 chnget "O2sync"

;calculate cps
if kbend >= 0 then 
kbend2=kbend*kOsc2up
else
kbend2=kbend*kOsc2down
endif

kcps21=cpsmidinn(kss+((p4-kss)*ksc)+kvib+kbend2+kfine2+kcoarse2+kRNGnote)
kcps22=kcps21*krmratio2
kenv2 madsr iattack2,idecay2,isustain2,irelease2
;add jitter
kcpsjit2 jitter .001*kcps21,.5,15
if ksync2==1 then
aindex2a,a2syncout syncphasor kcps21+kcpsjit2,async1out
else
aindex2a phasor kcps21+kcpsjit2
endif
aindex2b    phasor  kcps22
;oscillator function select logic
if kfn2==1 then
aosc2	tablei	aindex2a*kPW2,101,1	; audio oscillator read wave created
elseif kfn2==2 then
aosc2	tablei	aindex2a*kPW2,102,1
elseif kfn2==3 then
aosc2	tablei	aindex2a*kPW2,103,1
elseif kfn2==4 then
aosc2	tablei	aindex2a*kPW2,104,1
endif
;oscillator RM logic
if krm2==2 then
aosc2RM	tablei	aindex2b*kPW2,101,1
elseif krm2==3 then
aosc2RM	tablei	aindex2b*kPW2,102,1
elseif krm2==4 then
aosc2RM	tablei	aindex2b*kPW2,103,1
elseif krm2==5 then
aosc2RM	tablei	aindex2b*kPW2,104,1
elseif krm2==6 then
aosc2RM	tablei	aindex2b*kPW2,25,1
elseif krm2==7 then
aosc2RM	tablei	aindex2b*kPW2,28,1
elseif krm2==1 then
goto noRM2 ;skip over RM operation if no RM selected
endif
;RM
aosc2=aosc2*aosc2RM

noRM2:
aoscmaster2=aosc2*kosc2amp*kosc2level*kenv2*.3 ;just used for balance below, not for output
a21 balance aosc2,aoscmaster2
a21=a21*p5
a22 delay1 a21
a21=(a21+a22)*.5   ;simple LP filter with Nyquist cutoff
a2L=a21*(1-kpan2)
a2R=a21*kpan2

;OSCILLATOR 3 DEFINED IN THIS LARGE SECTION
;;get GUI data
kosc3on chnget "osc3"
kosc3amp port kosc3on,.03
kosc3level chnget "Osc3amp"
iattack3 chnget "Osc3attack"  ;need to make sure the chnget info is specific to each oscillator so need to rename from here on down
idecay3 chnget "Osc3decay"
isustain3 chnget "Osc3sustain"
irelease3 chnget "Osc3release"
kPW3 chnget "Osc3PW"
kcoarse3 chnget "Osc3Tcoarse"
kfine3 chnget "Osc3Tfine"
kfn3 chnget "Osc3fn"
krm3 chnget "RMselect3"
krmratio3 chnget "RMratio3"
kpan3 chnget "pan3"
ksync3 chnget "O3sync"

;calculate cps
if kbend >= 0 then 
kbend3=kbend*kOsc3up
else
kbend3=kbend*kOsc3down
endif

kcps31=cpsmidinn(kss+((p4-kss)*ksc)+kvib+kbend3+kfine3+kcoarse3+kRNGnote)
kcps32=kcps31*krmratio3
kenv3 madsr iattack3,idecay3,isustain3,irelease3
;add jitter
kcpsjit3 jitter .001*kcps31,.5,15
if ksync3==1 then
aindex3a,a3syncout syncphasor kcps31+kcpsjit3,async1out
else
aindex3a phasor kcps31+kcpsjit3
endif
aindex3b    phasor  kcps32
;oscillator function select logic
if kfn3==1 then
aosc3	tablei	aindex3a*kPW3,101,1	; audio oscillator read wave created
elseif kfn3==2 then
aosc3	tablei	aindex3a*kPW3,102,1
elseif kfn3==3 then
aosc3	tablei	aindex3a*kPW3,103,1
elseif kfn3==4 then
aosc3	tablei	aindex3a*kPW3,104,1
endif
;oscillator RM logic
if krm3==2 then
aosc3RM	tablei	aindex3b*kPW3,101,1
elseif krm3==3 then
aosc3RM	tablei	aindex3b*kPW3,102,1
elseif krm3==4 then
aosc3RM	tablei	aindex3b*kPW3,103,1
elseif krm3==5 then
aosc3RM	tablei	aindex3b*kPW3,104,1
elseif krm3==6 then
aosc3RM	tablei	aindex3b*kPW3,25,1
elseif krm3==7 then
aosc3RM	tablei	aindex3b*kPW3,28,1
elseif krm3==1 then
goto noRM3 ;skip over RM operation if no RM selected
endif
;RM
aosc3=aosc3*aosc3RM

noRM3:
aoscmaster3=aosc3*kosc3amp*kosc3level*kenv3*.3 ;just used for balance below, not for output
a31 balance aosc3,aoscmaster3
a31=a31*(p5+kRNGamprand)
a32 delay1 a31
a31=(a31+a32)*.5   ;simple LP filter with Nyquist cutoff
a3L=a31*(1-kpan3)
a3R=a31*kpan3

;sum all three oscillators
aL=a1L+a2L+a3L
aR=a1R+a2R+a3R

gaSynL=gaSynL+aL
gaSynR=gaSynR+aR
endin

instr 100   ;instrument to monitor MIDI controller numbers, creates global MIDI outputs that are evaluated by instr 110-300             
gkstatus,gkchan,gkdata1,gkdata2 midiin
if changed(gkstatus)==1 then  
    if gkstatus==176 then
    chnset gkdata1,"CtrlNum" ;displays current controller number in GUI
    endif
endif
endin

instr 110
;receive MIDI mapping buttons for Wave 1
kmapW1WRate chnget "mapW1WRate"
kmapW1WRateX chnget "mapW1WRateX"
kmapW1WRR chnget "mapW1WRR"
kmapW1WRRX chnget "mapW1WRRX"
kmapW1WSmooth chnget "mapW1WSmooth"
kmapW1WSmoothX chnget "mapW1WSmoothX"
kmapW1RandRate chnget "mapW1RandRate"
kmapW1RandRateX chnget "mapW1RandRateX"
kmapW1RR chnget "mapW1RR"
kmapW1RRX chnget "mapW1RRX"
kmapW1RandDev chnget "mapW1RandDev"
kmapW1RandDevX chnget "mapW1RandDevX"
kmapW1RandScale chnget "mapW1RandScale"
kmapW1RandScaleX chnget "mapW1RandScaleX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapW1WRate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 111, 2, 0
            event "i", 111, 0, 999999999
        elseif kmapW1WRR == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 112, 2, 0
            event "i", 112, 0, 999999999
        elseif kmapW1WSmooth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 113, 2, 0
            event "i", 113, 0, 999999999
        elseif kmapW1RandRate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 114, 2, 0
            event "i", 114, 0, 999999999
        elseif kmapW1RR == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 115, 2, 0
            event "i", 115, 0, 999999999
        elseif kmapW1RandDev == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 116, 2, 0
            event "i", 116, 0, 999999999
        elseif kmapW1RandScale == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 117, 2, 0
            event "i", 117, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapW1WRateX == 1 then
    turnoff2 111, 2, 0
elseif kmapW1WRRX == 1 then
    turnoff2 112, 2, 0
elseif kmapW1WSmoothX == 1 then
    turnoff2 113, 2, 0
elseif kmapW1RandRateX == 1 then
    turnoff2 114, 2, 0
elseif kmapW1RRX == 1 then
    turnoff2 115, 2, 0
elseif kmapW1RandDevX == 1 then
    turnoff2 116, 2, 0
elseif kmapW1RandScaleX == 1 then
    turnoff2 117, 2, 0
endif
endin

instr 111 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1WRate"
endin

instr 112 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1WRR"
endin

instr 113 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1Wsmooth"
endin

instr 114 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,15 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1RandRate"
endin

instr 115 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1RR"
endin

instr 116 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1RandDev"
endin

instr 117 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W1RandScale"
endin

instr 120
;receive MIDI mapping buttons for Wave 2
kmapW2WRate chnget "mapW2WRate"
kmapW2WRateX chnget "mapW2WRateX"
kmapW2WRR chnget "mapW2WRR"
kmapW2WRRX chnget "mapW2WRRX"
kmapW2WSmooth chnget "mapW2WSmooth"
kmapW2WSmoothX chnget "mapW2WSmoothX"
kmapW2RandRate chnget "mapW2RandRate"
kmapW2RandRateX chnget "mapW2RandRateX"
kmapW2RR chnget "mapW2RR"
kmapW2RRX chnget "mapW2RRX"
kmapW2RandDev chnget "mapW2RandDev"
kmapW2RandDevX chnget "mapW2RandDevX"
kmapW2RandScale chnget "mapW2RandScale"
kmapW2RandScaleX chnget "mapW2RandScaleX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapW2WRate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 121, 2, 0
            event "i", 121, 0, 999999999
        elseif kmapW2WRR == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 122, 2, 0
            event "i", 122, 0, 999999999
        elseif kmapW2WSmooth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 123, 2, 0
            event "i", 123, 0, 999999999
        elseif kmapW2RandRate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 124, 2, 0
            event "i", 124, 0, 999999999
        elseif kmapW2RR == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 125, 2, 0
            event "i", 125, 0, 999999999
        elseif kmapW2RandDev == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 126, 2, 0
            event "i", 126, 0, 999999999
        elseif kmapW2RandScale == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 127, 2, 0
            event "i", 127, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapW2WRateX == 1 then
    turnoff2 121, 2, 0
elseif kmapW2WRRX == 1 then
    turnoff2 122, 2, 0
elseif kmapW2WSmoothX == 1 then
    turnoff2 123, 2, 0
elseif kmapW2RandRateX == 1 then
    turnoff2 124, 2, 0
elseif kmapW2RRX == 1 then
    turnoff2 125, 2, 0
elseif kmapW2RandDevX == 1 then
    turnoff2 126, 2, 0
elseif kmapW2RandScaleX == 1 then
    turnoff2 127, 2, 0
endif
endin

instr 121 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2WRate"
endin

instr 122 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2WRR"
endin

instr 123 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2Wsmooth"
endin

instr 124 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,15 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2RandRate"
endin

instr 125 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2RR"
endin

instr 126 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,2 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2RandDev"
endin

instr 127 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W2RandScale"
endin

instr 130
;receive MIDI mapping buttons for Waves 3 and 4
kmapW3WRate chnget "mapW3Rate"
kmapW3WRateX chnget "mapW3RateX"
kmapW4WRate chnget "mapW4Rate"
kmapW4WRateX chnget "mapW4RateX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapW3WRate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 131, 2, 0
            event "i", 131, 0, 999999999
        elseif kmapW4WRate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 132, 2, 0
            event "i", 132, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapW3WRateX == 1 then
    turnoff2 131, 2, 0
elseif kmapW4WRateX == 1 then
    turnoff2 132, 2, 0
endif
endin

instr 131 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,15 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W3RandRate"
endin

instr 132 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,15 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "W4RandRate"
endin

instr 140
;receive MIDI mapping buttons for Oscillator 1
kmapOsc1amp chnget  "mapOsc1amp"
kmapOsc1ampX chnget  "mapOsc1ampX"
kmapOsc1Tcoarse chnget  "mapOsc1Tcoarse"
kmapOsc1TcoarseX chnget "mapOsc1TcoarseX"
kmapOsc1Tfine chnget "mapOsc1Tfine"
kmapOsc1TfineX chnget "mapOsc1TfineX"
kmapOsc1attack chnget "mapOsc1attack"
kmapOsc1attackX chnget "mapOsc1attackX"
kmapOsc1decay chnget "mapOsc1decay"
kmapOsc1decayX chnget  "mapOsc1decayX"
kmapOsc1sustain chnget  "mapOsc1sustain"
kmapOsc1sustainX chnget  "mapOsc1sustainX"
kmapOsc1release chnget  "mapOsc1release"
kmapOsc1releaseX chnget  "mapOsc1releaseX"
kmappan1 chnget  "mappan1"
kmappan1X chnget  "mappan1X"
kmapRMratio1 chnget  "mapRMratio1"
kmapRMratio1X chnget  "mapRMratio1X"
kmapPW1 chnget  "mapPW1"
kmapPW1X chnget  "mapPW1X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapOsc1amp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 141, 2, 0
            event "i", 141, 0, 999999999
        elseif kmapOsc1Tcoarse == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 142, 2, 0
            event "i", 142, 0, 999999999
        elseif kmapOsc1Tfine == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 143, 2, 0
            event "i", 143, 0, 999999999
        elseif kmapOsc1attack == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 144, 2, 0
            event "i", 144, 0, 999999999
        elseif kmapOsc1decay == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 145, 2, 0
            event "i", 145, 0, 999999999
        elseif kmapOsc1sustain == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 146, 2, 0
            event "i", 146, 0, 999999999
        elseif kmapOsc1release == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 147, 2, 0
            event "i", 147, 0, 999999999
        elseif kmappan1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 148, 2, 0
            event "i", 148, 0, 999999999
        elseif kmapRMratio1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 149, 2, 0
            event "i", 149, 0, 999999999
        elseif kmapPW1 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 150, 2, 0
            event "i", 150, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapOsc1ampX == 1 then
    turnoff2 141, 2, 0
elseif kmapOsc1TcoarseX == 1 then
    turnoff2 142, 2, 0
elseif kmapOsc1TfineX == 1 then
    turnoff2 143, 2, 0
elseif kmapOsc1attackX == 1 then
    turnoff2 144, 2, 0
elseif kmapOsc1decayX == 1 then
    turnoff2 145, 2, 0
elseif kmapOsc1sustainX == 1 then
    turnoff2 146, 2, 0
elseif kmapOsc1releaseX == 1 then
    turnoff2 147, 2, 0
elseif kmappan1X == 1 then
    turnoff2 148, 2, 0
elseif kmapRMratio1X == 1 then
    turnoff2 149, 2, 0
elseif kmapPW1X == 1 then
    turnoff2 150, 2, 0
endif
endin

instr 141 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1amp"
endin

instr 142 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1Tcoarse"
endin

instr 143 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1Tfine"
endin

instr 144 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1attack"
endin

instr 145 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1decay"
endin

instr 146 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1sustain"
endin

instr 147 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1release"
endin

instr 148 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pan1"
endin

instr 149 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RMratio1"
endin

instr 150 ;MIDI mapping for Osc1RandDev
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc1PW"
endin

instr 160
;receive MIDI mapping buttons for Oscillator 2
kmapOsc2amp chnget  "mapOsc2amp"
kmapOsc2ampX chnget  "mapOsc2ampX"
kmapOsc2Tcoarse chnget  "mapOsc2Tcoarse"
kmapOsc2TcoarseX chnget "mapOsc2TcoarseX"
kmapOsc2Tfine chnget "mapOsc2Tfine"
kmapOsc2TfineX chnget "mapOsc2TfineX"
kmapOsc2attack chnget "mapOsc2attack"
kmapOsc2attackX chnget "mapOsc2attackX"
kmapOsc2decay chnget "mapOsc2decay"
kmapOsc2decayX chnget  "mapOsc2decayX"
kmapOsc2sustain chnget  "mapOsc2sustain"
kmapOsc2sustainX chnget  "mapOsc2sustainX"
kmapOsc2release chnget  "mapOsc2release"
kmapOsc2releaseX chnget  "mapOsc2releaseX"
kmappan2 chnget  "mappan2"
kmappan2X chnget  "mappan2X"
kmapRMratio2 chnget  "mapRMratio2"
kmapRMratio2X chnget  "mapRMratio2X"
kmapPW2 chnget  "mapPW2"
kmapPW2X chnget  "mapPW2X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapOsc2amp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 161, 2, 0
            event "i", 161, 0, 999999999
        elseif kmapOsc2Tcoarse == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 162, 2, 0
            event "i", 162, 0, 999999999
        elseif kmapOsc2Tfine == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 163, 2, 0
            event "i", 163, 0, 999999999
        elseif kmapOsc2attack == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 164, 2, 0
            event "i", 164, 0, 999999999
        elseif kmapOsc2decay == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 165, 2, 0
            event "i", 165, 0, 999999999
        elseif kmapOsc2sustain == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 166, 2, 0
            event "i", 166, 0, 999999999
        elseif kmapOsc2release == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 167, 2, 0
            event "i", 167, 0, 999999999
        elseif kmappan2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 168, 2, 0
            event "i", 168, 0, 999999999
        elseif kmapRMratio2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 169, 2, 0
            event "i", 169, 0, 999999999
        elseif kmapPW2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 170, 2, 0
            event "i", 170, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapOsc2ampX == 1 then
    turnoff2 161, 2, 0
elseif kmapOsc2TcoarseX == 1 then
    turnoff2 162, 2, 0
elseif kmapOsc2TfineX == 1 then
    turnoff2 163, 2, 0
elseif kmapOsc2attackX == 1 then
    turnoff2 164, 2, 0
elseif kmapOsc2decayX == 1 then
    turnoff2 165, 2, 0
elseif kmapOsc2sustainX == 1 then
    turnoff2 166, 2, 0
elseif kmapOsc2releaseX == 1 then
    turnoff2 167, 2, 0
elseif kmappan2X == 1 then
    turnoff2 168, 2, 0
elseif kmapRMratio2X == 1 then
    turnoff2 169, 2, 0
elseif kmapPW2X == 1 then
    turnoff2 170, 2, 0
endif
endin

instr 161 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2amp"
endin

instr 162 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2Tcoarse"
endin

instr 163 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2Tfine"
endin

instr 164 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2attack"
endin

instr 165 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2decay"
endin

instr 166 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2sustain"
endin

instr 167 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2release"
endin

instr 168 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pan2"
endin

instr 169 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RMratio2"
endin

instr 170 ;MIDI mapping for Osc2
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc2PW"
endin

instr 180
;receive MIDI mapping buttons for Oscillator 3
kmapOsc3amp chnget  "mapOsc3amp"
kmapOsc3ampX chnget  "mapOsc3ampX"
kmapOsc3Tcoarse chnget  "mapOsc3Tcoarse"
kmapOsc3TcoarseX chnget "mapOsc3TcoarseX"
kmapOsc3Tfine chnget "mapOsc3Tfine"
kmapOsc3TfineX chnget "mapOsc3TfineX"
kmapOsc3attack chnget "mapOsc3attack"
kmapOsc3attackX chnget "mapOsc3attackX"
kmapOsc3decay chnget "mapOsc3decay"
kmapOsc3decayX chnget  "mapOsc3decayX"
kmapOsc3sustain chnget  "mapOsc3sustain"
kmapOsc3sustainX chnget  "mapOsc3sustainX"
kmapOsc3release chnget  "mapOsc3release"
kmapOsc3releaseX chnget  "mapOsc3releaseX"
kmappan3 chnget  "mappan3"
kmappan3X chnget  "mappan3X"
kmapRMratio3 chnget  "mapRMratio3"
kmapRMratio3X chnget  "mapRMratio3X"
kmapPW3 chnget  "mapPW3"
kmapPW3X chnget  "mapPW3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapOsc3amp == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 181, 2, 0
            event "i", 181, 0, 999999999
        elseif kmapOsc3Tcoarse == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 182, 2, 0
            event "i", 182, 0, 999999999
        elseif kmapOsc3Tfine == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 183, 2, 0
            event "i", 183, 0, 999999999
        elseif kmapOsc3attack == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 184, 2, 0
            event "i", 184, 0, 999999999
        elseif kmapOsc3decay == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 185, 2, 0
            event "i", 185, 0, 999999999
        elseif kmapOsc3sustain == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 186, 2, 0
            event "i", 186, 0, 999999999
        elseif kmapOsc3release == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 187, 2, 0
            event "i", 187, 0, 999999999
        elseif kmappan3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 188, 2, 0
            event "i", 188, 0, 999999999
        elseif kmapRMratio3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 189, 2, 0
            event "i", 189, 0, 999999999
        elseif kmapPW3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 190, 2, 0
            event "i", 190, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapOsc3ampX == 1 then
    turnoff2 181, 2, 0
elseif kmapOsc3TcoarseX == 1 then
    turnoff2 182, 2, 0
elseif kmapOsc3TfineX == 1 then
    turnoff2 183, 2, 0
elseif kmapOsc3attackX == 1 then
    turnoff2 184, 2, 0
elseif kmapOsc3decayX == 1 then
    turnoff2 185, 2, 0
elseif kmapOsc3sustainX == 1 then
    turnoff2 186, 2, 0
elseif kmapOsc3releaseX == 1 then
    turnoff2 187, 2, 0
elseif kmappan3X == 1 then
    turnoff2 188, 2, 0
elseif kmapRMratio3X == 1 then
    turnoff2 189, 2, 0
elseif kmapPW3X == 1 then
    turnoff2 190, 2, 0
endif
endin

instr 181 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3amp"
endin

instr 182 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3Tcoarse"
endin

instr 183 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3Tfine"
endin

instr 184 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3attack"
endin

instr 185 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3decay"
endin

instr 186 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3sustain"
endin

instr 187 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3release"
endin

instr 188 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "pan3"
endin

instr 189 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,5 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RMratio3"
endin

instr 190 ;MIDI mapping for Osc3
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,10 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "Osc3PW"
endin

instr 200
;receive MIDI mapping buttons for RNG
kmapRNGrate chnget "mapRNGrate"
kmapRNGrateX chnget "mapRNGrateX"
kmapRNGraterand chnget "mapRNGraterand"
kmapRNGraterandX chnget "mapRNGraterandX"
kmapRNGamprand chnget "mapRNGamprand"
kmapRNGamprandX chnget "mapRNGamprandX"
kmapRNGdev chnget "mapRNGdev"
kmapRNGdevX chnget "mapRNGdevX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapRNGrate == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 201, 2, 0
            event "i", 201, 0, 999999999
        elseif kmapRNGraterand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 202, 2, 0
            event "i", 202, 0, 999999999
        elseif kmapRNGamprand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 203, 2, 0
            event "i", 203, 0, 999999999
        elseif kmapRNGdev == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 204, 2, 0
            event "i", 204, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapRNGrateX == 1 then
    turnoff2 201, 2, 0
elseif kmapRNGraterandX == 1 then
    turnoff2 202, 2, 0
elseif kmapRNGamprandX == 1 then
    turnoff2 203, 2, 0
elseif kmapRNGdevX == 1 then
    turnoff2 204, 2, 0
endif
endin

instr 201 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGrate"
endin

instr 202 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGraterand"
endin

instr 203 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.95 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGamprand"
endin

instr 204 ;MIDI mapping for RNG
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,60 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "RNGdev"
endin

instr 210
;receive MIDI mapping buttons for Distortion
kmapdist chnget "mapdist"
kmapdistX chnget "mapdistX"
kmapdist2 chnget "mapdist2"
kmapdist2X chnget "mapdist2X"
kmapdist3 chnget "mapdist3"
kmapdist3X chnget "mapdist3X"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdist == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 211, 2, 0
            event "i", 211, 0, 999999999
        elseif kmapdist2 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 212, 2, 0
            event "i", 212, 0, 999999999
        elseif kmapdist3 == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 213, 2, 0
            event "i", 213, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdistX == 1 then
    turnoff2 211, 2, 0
elseif kmapdist2X == 1 then
    turnoff2 212, 2, 0
elseif kmapdist3X == 1 then
    turnoff2 213, 2, 0
endif
endin

instr 211 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist"
endin

instr 212 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist2"
endin

instr 213 ;MIDI mapping for Distortion
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,1,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "dist3"
endin

instr 220
;receive MIDI mapping buttons for Vibrato
kmapvibrand chnget "mapvibrand"
kmapvibrandX chnget "mapvibrandX"
kmapvibcps chnget "mapvibcps"
kmapvibcpsX chnget "mapvibcpsX"
kmapvibdepth chnget "mapvibdepth"
kmapvibdepthX chnget "mapvibdepthX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapvibrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 221, 2, 0
            event "i", 221, 0, 999999999
        elseif kmapvibcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 222, 2, 0
            event "i", 222, 0, 999999999
        elseif kmapvibdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 223, 2, 0
            event "i", 223, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapvibrandX == 1 then
    turnoff2 221, 2, 0
elseif kmapvibcpsX == 1 then
    turnoff2 222, 2, 0
elseif kmapvibdepthX == 1 then
    turnoff2 223, 2, 0
endif
endin

instr 221 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibrand"
endin

instr 222 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibcps"
endin

instr 223 ;MIDI mapping for Vibrato
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "vibdepth"
endin

instr 230
;receive MIDI mapping buttons for Lowpass
kmapLPcps chnget "mapLPcps"
kmapLPcpsX chnget "mapLPcpsX"
kmapLPres chnget "mapLPres"
kmapLPresX chnget "mapLPresX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapLPcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 231, 2, 0
            event "i", 231, 0, 999999999
        elseif kmapLPres == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 232, 2, 0
            event "i", 232, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapLPcpsX == 1 then
    turnoff2 231, 2, 0
elseif kmapLPresX == 1 then
    turnoff2 232, 2, 0
endif
endin

instr 231 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,100,15000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPcps"
endin

instr 232 ;MIDI mapping for Lowpass
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "LPres"
endin

instr 240
;receive MIDI mapping buttons for Phaser
kmapphscps chnget "mapphscps"
kmapphscpsX chnget "mapphscpsX"
kmapphsFB chnget "mapphsFB"
kmapphsFBX chnget "mapphsFBX"
kmapphsQ chnget "mapphsQ"
kmapphsQX chnget "mapphsQX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapphscps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 241, 2, 0
            event "i", 241, 0, 999999999
        elseif kmapphsFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 242, 2, 0
            event "i", 242, 0, 999999999
        elseif kmapphsQ == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 243, 2, 0
            event "i", 243, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapphscpsX == 1 then
    turnoff2 241, 2, 0
elseif kmapphsFBX == 1 then
    turnoff2 242, 2, 0
elseif kmapphsQX == 1 then
    turnoff2 243, 2, 0
endif
endin

instr 241 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phscps"
endin

instr 242 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsFB"
endin

instr 243 ;MIDI mapping for Phaser
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "phsQ"
endin

instr 250
;receive MIDI mapping buttons for Flanger
kmapflcps chnget "mapflcps"
kmapflcpsX chnget "mapflcpsX"
kmapflFB chnget "mapflFB"
kmapflFBX chnget "mapflFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapflcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 251, 2, 0
            event "i", 251, 0, 999999999
        elseif kmapflFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 252, 2, 0
            event "i", 252, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapflcpsX == 1 then
    turnoff2 251, 2, 0
elseif kmapflFBX == 1 then
    turnoff2 252, 2, 0
endif
endin

instr 251 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,100 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flcps"
endin

instr 252 ;MIDI mapping for Flanger
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "flFB"
endin

instr 260
;receive MIDI mapping buttons for Transposer
kmapharmmix chnget "mapharmmix"
kmapharmmixX chnget "mapharmmixX"
kmapharmon1C chnget "mapharmon1C"
kmapharmon1CX chnget "mapharmon1CX"
kmapharmon1F chnget "mapharmon1F"
kmapharmon1FX chnget "mapharmon1FX"
kmapharmon2C chnget "mapharmon2C"
kmapharmon2CX chnget "mapharmon2CX"
kmapharmon2F chnget "mapharmon2F"
kmapharmon2FX chnget "mapharmon2FX"
kmapharmon3C chnget "mapharmon3C"
kmapharmon3CX chnget "mapharmon3CX"
kmapharmon3F chnget "mapharmon3F"
kmapharmon3FX chnget "mapharmon3FX"
kmapharmon4C chnget "mapharmon4C"
kmapharmon4CX chnget "mapharmon4CX"
kmapharmon4F chnget "mapharmon4F"
kmapharmon4FX chnget "mapharmon4FX"
kmapharmon5C chnget "mapharmon5C"
kmapharmon5CX chnget "mapharmon5CX"
kmapharmon5F chnget "mapharmon5F"
kmapharmon5FX chnget "mapharmon5FX"
kmapharmon6C chnget "mapharmon6C"
kmapharmon6CX chnget "mapharmon6CX"
kmapharmon6F chnget "mapharmon6F"
kmapharmon6FX chnget "mapharmon6FX"


;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapharmmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 261, 2, 0
            event "i", 261, 0, 999999999
        elseif kmapharmon1C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 262, 2, 0
            event "i", 262, 0, 999999999
        elseif kmapharmon1F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 263, 2, 0
            event "i", 263, 0, 999999999
        elseif kmapharmon2C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 264, 2, 0
            event "i", 264, 0, 999999999
        elseif kmapharmon2F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 265, 2, 0
            event "i", 265, 0, 999999999
        elseif kmapharmon3C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 266, 2, 0
            event "i", 266, 0, 999999999
        elseif kmapharmon3F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 267, 2, 0
            event "i", 267, 0, 999999999
        elseif kmapharmon4C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 268, 2, 0
            event "i", 268, 0, 999999999
        elseif kmapharmon4F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 269, 2, 0
            event "i", 269, 0, 999999999
        elseif kmapharmon5C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 270, 2, 0
            event "i", 270, 0, 999999999
        elseif kmapharmon5F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 271, 2, 0
            event "i", 271, 0, 999999999
        elseif kmapharmon6C == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 272, 2, 0
            event "i", 272, 0, 999999999
        elseif kmapharmon6F == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 273, 2, 0
            event "i", 273, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapharmmixX == 1 then
    turnoff2 261, 2, 0
elseif kmapharmon1CX == 1 then
    turnoff2 262, 2, 0
elseif kmapharmon1FX == 1 then
    turnoff2 263, 2, 0
elseif kmapharmon2CX == 1 then
    turnoff2 264, 2, 0
elseif kmapharmon2FX == 1 then
    turnoff2 265, 2, 0
elseif kmapharmon3CX == 1 then
    turnoff2 266, 2, 0
elseif kmapharmon3FX == 1 then
    turnoff2 267, 2, 0
elseif kmapharmon4CX == 1 then
    turnoff2 268, 2, 0
elseif kmapharmon4FX == 1 then
    turnoff2 269, 2, 0
elseif kmapharmon5CX == 1 then
    turnoff2 270, 2, 0
elseif kmapharmon5FX == 1 then
    turnoff2 271, 2, 0
elseif kmapharmon6CX == 1 then
    turnoff2 272, 2, 0
elseif kmapharmon6FX == 1 then
    turnoff2 273, 2, 0
endif
endin

instr 261 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmmix"
endin

instr 262 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1C"
endin

instr 263 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon1F"
endin

instr 264 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2C"
endin

instr 265 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon2F"
endin

instr 266 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3C"
endin

instr 267 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon3F"
endin

instr 268 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4C"
endin

instr 269 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon4F"
endin

instr 270 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5C"
endin

instr 271 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon5F"
endin

instr 272 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-24,24 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6C"
endin

instr 273 ;MIDI mapping for Transposer
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,-1,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "harmon6F"
endin

instr 280
;receive MIDI mapping buttons for Chorus
kmapchmix chnget "mapchmix"
kmapchmixX chnget "mapchmixX"
kmapchcps chnget "mapchcps"
kmapchcpsX chnget "mapchcpsX"
kmapchFB chnget "mapchFB"
kmapchFBX chnget "mapchFBX"
kmapchdepth chnget "mapchdepth"
kmapchdepthX chnget "mapchdepthX"
kmapchdel chnget "mapchdel"
kmapchdelX chnget "mapchdelX"
kmapchrand chnget "mapchrand"
kmapchrandX chnget "mapchrandX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapchmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 281, 2, 0
            event "i", 281, 0, 999999999
        elseif kmapchcps == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 282, 2, 0
            event "i", 282, 0, 999999999
        elseif kmapchFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 283, 2, 0
            event "i", 283, 0, 999999999
        elseif kmapchdepth == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 284, 2, 0
            event "i", 284, 0, 999999999
        elseif kmapchdel == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 285, 2, 0
            event "i", 285, 0, 999999999
        elseif kmapchrand == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 286, 2, 0
            event "i", 286, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapchmixX == 1 then
    turnoff2 281, 2, 0
elseif kmapchcpsX == 1 then
    turnoff2 282, 2, 0
elseif kmapchFBX == 1 then
    turnoff2 283, 2, 0
elseif kmapchdepthX == 1 then
    turnoff2 284, 2, 0
elseif kmapchdelX == 1 then
    turnoff2 285, 2, 0
elseif kmapchrandX == 1 then
    turnoff2 286, 2, 0
endif
endin

instr 281 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chmix"
endin

instr 282 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,25 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chcps"
endin

instr 283 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chFB"
endin

instr 284 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdepth"
endin

instr 285 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.1,50 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chdel"
endin

instr 286 ;MIDI mapping for Chorus
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.9 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "chrand"
endin

instr 290
;receive MIDI mapping buttons for Delay
kmapdeltime chnget "mapdeltime"
kmapdeltimeX chnget "mapdeltimeX"
kmapdelFB chnget "mapdelFB"
kmapdelFBX chnget "mapdelFBX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmapdeltime == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 291, 2, 0
            event "i", 291, 0, 999999999
        elseif kmapdelFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 292, 2, 0
            event "i", 292, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmapdeltimeX == 1 then
    turnoff2 291, 2, 0
elseif kmapdelFBX == 1 then
    turnoff2 292, 2, 0
endif
endin

instr 291 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.001,4.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "deltime"
endin

instr 292 ;MIDI mapping for Delay
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,.99 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "delFB"
endin

instr 300
;receive MIDI mapping buttons for Reverb
kmaprevmix chnget "maprevmix"
kmaprevmixX chnget "maprevmixX"
kmaprevFB chnget "maprevFB"
kmaprevFBX chnget "maprevFBX"
kmaprevLP chnget "maprevLP"
kmaprevLPX chnget "maprevLPX"

;monitor controller changes and assign
if changed(gkstatus)==1 then  
    if gkstatus==176 then
        if kmaprevmix == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 301, 2, 0
            event "i", 301, 0, 999999999
        elseif kmaprevFB == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 302, 2, 0
            event "i", 302, 0, 999999999
        elseif kmaprevLP == 1 then ;map control change knob to GUI, trigger instrument for respective knob
            turnoff2 303, 2, 0
            event "i", 303, 0, 999999999
        endif
    endif
endif

;turn off MIDI controller GUI control for individual rsliders
if kmaprevmixX == 1 then
    turnoff2 301, 2, 0
elseif kmaprevFBX == 1 then
    turnoff2 302, 2, 0
elseif kmaprevLPX == 1 then
    turnoff2 303, 2, 0
endif
endin

instr 301 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,0,1 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revmix"
endin

instr 302 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,.01,.999 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revFB"
endin

instr 303 ;MIDI mapping for Reverb
ichan = i(gkchan)
idata1 = i(gkdata1)
ktr1 ctrl7 ichan,idata1,200,20000 ;map midi controller to GUI knob for ratios, scale values
chnset ktr1, "revLP"
endin

instr	400  ;F1 and F3 morphing function generato random sum of sines wave with smoothing

; read in widgets
kbase chnget "W1basewave"
kwrand chnget "W1WaveRand"
kwrate chnget "W1WRate"
kwratedev chnget "W1WRR"
kport chnget "W1Wsmooth"
krndR chnget "W1RandRate"
krndRR chnget "W1RR"
krndD chnget "W1RandDev"
krndscale chnget "W1RandScale"
kCrate chnget "W3RandRate"

if kwrand = 0 kgoto nextbase
;determine base wave rate of change
kWrndR randomh kwrate*(1-kwratedev),kwrate*(1+kwratedev),kwrate
kbase2 randomh 1,5.99,kWrndR,2
kbase=int(kbase2)

nextbase:

if (kbase == 1) then ;sine
    kb1=1
    kb2=0
    kb3=0
    kb4=0
    kb5=0
    kb6=0
    kb7=0
    kb8=0
    kb9=0
    kb10=0
    kb11=0
    kb12=0
    kb13=0
    kb14=0
    kb15=0
elseif (kbase == 2) then ;square
    kb1=1
    kb2=0
    kb3=.333333
    kb4=0
    kb5=.2
    kb6=0
    kb7=.142857
    kb8=0
    kb9=.111111
    kb10=0
    kb11=.090909
    kb12=0
    kb13=.076923
    kb14=0
    kb15=.0666666
elseif (kbase == 3) then ;saw
    kb1=1
    kb2=-.5
    kb3=.333333
    kb4=-.25
    kb5=.2
    kb6=-.166666
    kb7=.142857
    kb8=-.125
    kb9=.111111
    kb10=-.1
    kb11=.090909
    kb12=-.083333
    kb13=.076923
    kb14=-.071428
    kb15=.066666
elseif (kbase == 4) then ;triangle
    kb1=1
    kb2=0
    kb3=-.1111
    kb4=0
    kb5=.04
    kb6=0
    kb7=-.020408
    kb8=0
    kb9=.01234567
    kb10=0
    kb11=-.00826446
    kb12=0
    kb13=.00591715
    kb14=0
    kb15=-.00444444
elseif (kbase == 5) then ;pulse
    kb1=.1
    kb2=.1
    kb3=.1
    kb4=.1
    kb5=.1
    kb6=.1
    kb7=.1
    kb8=.1
    kb9=.1
    kb10=.2
    kb11=.2
    kb12=.2
    kb13=.2
    kb14=.095
    kb15=.09
endif

kb1 portk kb1,kport 
kb2 portk kb2,kport
kb3 portk kb3,kport
kb4 portk kb4,kport
kb5 portk kb5,kport
kb6 portk kb6,kport
kb7 portk kb7,kport
kb8 portk kb8,kport
kb9 portk kb9,kport
kb10 portk kb10,kport
kb11 portk kb11,kport
kb12 portk kb12,kport
kb13 portk kb13,kport
kb14 portk kb14,kport
kb15 portk kb15,kport

krlow=krndR*(1-krndRR)
krhigh=krndR*(1+krndRR)

kr1 jitter krndD,krlow,krhigh ;random partial strengths calculated--maybe uses more cpu than the random paradigm below
kr2 jitter krndD,krlow,krhigh
kr3 jitter krndD,krlow,krhigh
kr4 jitter krndD,krlow,krhigh
kr5 jitter krndD,krlow,krhigh
kr6 jitter krndD,krlow,krhigh
kr7 jitter krndD,krlow,krhigh
kr8 jitter krndD,krlow,krhigh
kr9 jitter krndD,krlow,krhigh
kr10 jitter krndD,krlow,krhigh
kr11 jitter krndD,krlow,krhigh
kr12 jitter krndD,krlow,krhigh
kr13 jitter krndD,krlow,krhigh
kr14 jitter krndD,krlow,krhigh
kr15 jitter krndD,krlow,krhigh

;krate1 randomh krlow,krhigh,krndR  ;the old model--not seeded, could try randh with seed value 2 instead of jitter model
;kr1 randi krndD,krate1

krndscale=1-krndscale
k1=kb1+kr1  ;base amp plus random deviation*harmonic scaling
k2=kb2+kr2*(.25+(krndscale*.75))
k3=kb3+kr3*(.1111+(krndscale*.8889))
k4=kb4+kr4*(.0625+(krndscale*.9375))
k5=kb5+kr5*(.04+(krndscale*.96))
k6=kb6+kr6*(.0278+(krndscale*.9722))
k7=kb7+kr7*(.0204+(krndscale*.9796))
k8=kb8+kr8*(.0156+(krndscale*.9844))
k9=kb9+kr9*(.0124+(krndscale*.9876))
k10=kb10+kr10*(.01+(krndscale*.99))
k11=kb11+kr11*(.0083+(krndscale*.9917))
k12=kb12+kr12*(.0069+(krndscale*.9931))
k13=kb13+kr13*(.0059+(krndscale*.9941))
k14=kb14+kr14*(.0051+(krndscale*.9949))
k15=kb15+kr15*(.0045+(krndscale*.9955))

;this setion genertes the random cubic spline curve function:
kstr1	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr2	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr3	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr4	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr5	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr6	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr7	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr8	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr9	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr10	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr11	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr12	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr13	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr14	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr15	rspline	-0.9,0.9,0.1*kCrate,kCrate

;now redraw the functions
	if metro(64)==1 then	; peg rate of update. Tables updated at this rate. If too slow, glitching will be heard in the output, particularly if random movement speed is high. If too high CPU performance will suffer.
	 reinit	UPDATE
	endif
	UPDATE:
    giwave	ftgen	101,0,8192,10,i(k1),i(k2),i(k3),i(k4),i(k5),i(k6),i(k7),i(k8),i(k9),i(k10),i(k11),i(k12),i(k13),i(k14),i(k15) ;,i(k16),i(k17),i(k18),i(k19),i(k20)
	giwave	ftgen	103,0,8192,8,0,512,i(kstr1),512,i(kstr2),512,i(kstr3),512,i(kstr4),512,i(kstr5),512,i(kstr6),512,i(kstr7),512,i(kstr8),512,i(kstr9),512,i(kstr10),512,i(kstr11),512,i(kstr12),512,i(kstr13),512,i(kstr14),512,i(kstr15),512,0

		rireturn

contin:
	if metro(32)==1 then			; peg table display rate. Audio quality is unaffected by this.
	chnset	"tablenumber(101)", "table101"	; update table display	
	chnset	"tablenumber(103)", "table103"	; update table display	

	endif
endin

instr	401  ;random sum of sines wave with smoothing

; read in widgets
kbase chnget "W2basewave"
kwrand chnget "W2WaveRand"
kwrate chnget "W2WRate"
kwratedev chnget "W2WRR"
kport chnget "W2Wsmooth"
krndR chnget "W2RandRate"
krndRR chnget "W2RR"
krndD chnget "W2RandDev"
krndscale chnget "W2RandScale"
kCrate chnget "W4RandRate"

if kwrand = 0 kgoto nextbase
;determine base wave rate of change
kWrndR randomh kwrate*(1-kwratedev),kwrate*(1+kwratedev),kwrate
kbase2 randomh 1,5.99,kWrndR,2
kbase=int(kbase2)

nextbase:

if (kbase == 1) then ;sine
    kb1=1
    kb2=0
    kb3=0
    kb4=0
    kb5=0
    kb6=0
    kb7=0
    kb8=0
    kb9=0
    kb10=0
    kb11=0
    kb12=0
    kb13=0
    kb14=0
    kb15=0
elseif (kbase == 2) then ;square
    kb1=1
    kb2=0
    kb3=.333333
    kb4=0
    kb5=.2
    kb6=0
    kb7=.142857
    kb8=0
    kb9=.111111
    kb10=0
    kb11=.090909
    kb12=0
    kb13=.076923
    kb14=0
    kb15=.0666666
elseif (kbase == 3) then ;saw
    kb1=1
    kb2=-.5
    kb3=.333333
    kb4=-.25
    kb5=.2
    kb6=-.166666
    kb7=.142857
    kb8=-.125
    kb9=.111111
    kb10=-.1
    kb11=.090909
    kb12=-.083333
    kb13=.076923
    kb14=-.071428
    kb15=.066666
elseif (kbase == 4) then ;triangle
    kb1=1
    kb2=0
    kb3=-.1111
    kb4=0
    kb5=.04
    kb6=0
    kb7=-.020408
    kb8=0
    kb9=.01234567
    kb10=0
    kb11=-.00826446
    kb12=0
    kb13=.00591715
    kb14=0
    kb15=-.00444444
elseif (kbase == 5) then ;pulse
    kb1=.1
    kb2=.1
    kb3=.1
    kb4=.1
    kb5=.1
    kb6=.1
    kb7=.1
    kb8=.1
    kb9=.1
    kb10=.2
    kb11=.2
    kb12=.2
    kb13=.2
    kb14=.095
    kb15=.09
endif

kb1 portk kb1,kport 
kb2 portk kb2,kport
kb3 portk kb3,kport
kb4 portk kb4,kport
kb5 portk kb5,kport
kb6 portk kb6,kport
kb7 portk kb7,kport
kb8 portk kb8,kport
kb9 portk kb9,kport
kb10 portk kb10,kport
kb11 portk kb11,kport
kb12 portk kb12,kport
kb13 portk kb13,kport
kb14 portk kb14,kport
kb15 portk kb15,kport

krlow=krndR*(1-krndRR)
krhigh=krndR*(1+krndRR)

kr1 jitter krndD,krlow,krhigh ;random partial strengths calculated
kr2 jitter krndD,krlow,krhigh
kr3 jitter krndD,krlow,krhigh
kr4 jitter krndD,krlow,krhigh
kr5 jitter krndD,krlow,krhigh
kr6 jitter krndD,krlow,krhigh
kr7 jitter krndD,krlow,krhigh
kr8 jitter krndD,krlow,krhigh
kr9 jitter krndD,krlow,krhigh
kr10 jitter krndD,krlow,krhigh
kr11 jitter krndD,krlow,krhigh
kr12 jitter krndD,krlow,krhigh
kr13 jitter krndD,krlow,krhigh
kr14 jitter krndD,krlow,krhigh
kr15 jitter krndD,krlow,krhigh

;krate1 randomh krlow,krhigh,krndR ;this is the older model I used--basically jitter does the same with less code, probably no more efficient
;kr1 randi krndD,krate1

krndscale=1-krndscale
k1=kb1+kr1  ;base amp plus random deviation*harmonic scaling
k2=kb2+kr2*(.25+(krndscale*.75))
k3=kb3+kr3*(.1111+(krndscale*.8889))
k4=kb4+kr4*(.0625+(krndscale*.9375))
k5=kb5+kr5*(.04+(krndscale*.96))
k6=kb6+kr6*(.0278+(krndscale*.9722))
k7=kb7+kr7*(.0204+(krndscale*.9796))
k8=kb8+kr8*(.0156+(krndscale*.9844))
k9=kb9+kr9*(.0124+(krndscale*.9876))
k10=kb10+kr10*(.01+(krndscale*.99))
k11=kb11+kr11*(.0083+(krndscale*.9917))
k12=kb12+kr12*(.0069+(krndscale*.9931))
k13=kb13+kr13*(.0059+(krndscale*.9941))
k14=kb14+kr14*(.0051+(krndscale*.9949))
k15=kb15+kr15*(.0045+(krndscale*.9955))

;this setion genertes the random cubic spline curve function:

kstr41	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr42	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr43	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr44	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr45	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr46	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr47	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr48	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr49	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr50	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr51	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr52	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr53	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr54	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr55	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr56	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr57	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr58	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr59	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr60	rspline	-0.9,0.9,0.1*kCrate,kCrate
kstr61	rspline	-0.9,0.9,0.1*kCrate,kCrate

;now redraw the functions
	if metro(64)==1 then	; peg rate of update. Tables updated at this rate. If too slow, glitching will be heard in the output, particularly if random movement speed is high. If too high CPU performance will suffer.
	 reinit	UPDATE
	endif
	UPDATE:
    giwave	ftgen	102,0,8192,10,i(k1),i(k2),i(k3),i(k4),i(k5),i(k6),i(k7),i(k8),i(k9),i(k10),i(k11),i(k12),i(k13),i(k14),i(k15)
	giwave	ftgen	104,0,8192,8,0,96,i(kstr41),400,i(kstr42),400,i(kstr43),400,i(kstr44),400,i(kstr45),400,i(kstr46),400,i(kstr47),400,i(kstr48),400,i(kstr49),400,i(kstr50),400,i(kstr51),400,i(kstr52),400,i(kstr53),400,i(kstr54),400,i(kstr55),400,i(kstr56),400,i(kstr57),400,i(kstr58),400,i(kstr59),400,i(kstr60),400,i(kstr61),96,0
		rireturn

contin:
	if metro(32)==1 then			; peg table display rate. Audio quality is unaffected by this.
	chnset	"tablenumber(102)", "table102"	; update table display	
	chnset	"tablenumber(104)", "table104"	; update table display	
	endif
endin

instr 500   ;global FX for EQ, distortion, LP, Phaser, Flanger, etc
;input gaSynL and gaSynR, output gaFXL and gaFXR
;master effects section

aL=gaSynL
aR=gaSynR

;distortion
kdist chnget "dist"
kdist port kdist,.05
ad1L distort aL,kdist,26
ad1R distort aR,kdist,26
aL balance2 ad1L,aL
aR balance2 ad1R,aR

kdist2 chnget "dist2"
kdist2=1-kdist2
kdist2 port kdist2,.05
ad2L powershape aL,kdist2
ad2R powershape aR,kdist2
aL balance2 ad2L,aL
aR balance2 ad2R,aR

kdist3 chnget "dist3"
kdist3 port kdist3,.05
ad3L fold aL,kdist3
ad3R fold aR,kdist3
aL balance2 ad3L,aL
aR balance2 ad3R,aR

;LPfilter
kLPcps chnget "LPcps"
kLPcps port kLPcps,.025
kLPres chnget "LPres"
aL moogladder aL,kLPcps,kLPres
aR moogladder aR,kLPcps,kLPres
aL balance aL,gaSynL
aR balance aR,gaSynR

;phaser
kphson chnget "phson"
if kphson==0 goto nophaser
kphscps chnget "phscps"
kphsQ chnget "phsQ"
kphsFB chnget "phsFB"
kphsdev oscil 25,kphscps,25
aLphs phaser2 aL,100+kphsdev,kphsQ,20,1,1,kphsFB
aRphs phaser2 aR,100+kphsdev,kphsQ,20,1,1,kphsFB
aL=(aL+aLphs)*.5
aR=(aR+aRphs)*.5

nophaser:

;flanger
kflon chnget "flon"
if kflon==0 goto noflanger
kflcps chnget "flcps"
kflFB chnget "flFB"
adel oscil .02,kflcps,27
aLfl flanger aL,adel*.05,kflFB,.1
aLfl clip aLfl,1,1
aRfl flanger aR,adel*.05,kflFB,.1
aRfl clip aRfl,1,1
aL=(aL+aLfl)*.5
aR=(aR+aRfl)*.5

noflanger:
;global transposer with 6 voices
kharmon1 chnget "harmon1" ;on/off button
kharmon2 chnget "harmon2"
kharmon3 chnget "harmon3"
kharmon4 chnget "harmon4"
kharmon5 chnget "harmon5"
kharmon6 chnget "harmon6"
kharm1 port kharmon1,.05
kharm2 port kharmon2,.05
kharm3 port kharmon3,.05
kharm4 port kharmon4,.05
kharm5 port kharmon5,.05
kharm6 port kharmon6,.05

kT1C chnget "harmon1C"
kT1F chnget "harmon1F"
kT2C chnget "harmon2C"
kT2F chnget "harmon2F"
kT3C chnget "harmon3C"
kT3F chnget "harmon3F"
kT4C chnget "harmon4C"
kT4F chnget "harmon4F"
kT5C chnget "harmon5C"
kT5F chnget "harmon5F"
kT6C chnget "harmon6C"
kT6F chnget "harmon6F"

kshift1=kT1C+kT1F
kshift2=kT2C+kT2F
kshift3=kT3C+kT3F
kshift4=kT4C+kT4F
kshift5=kT5C+kT5F
kshift6=kT6C+kT6F
kharmmix chnget "harmmix"
ibase=cpsoct(8) ;middle C as base frequency

kratio1=cpsoct(8+(kshift1/12))/ibase ;Transposition ratio
kratio2=cpsoct(8+(kshift2/12))/ibase 
kratio3=cpsoct(8+(kshift3/12))/ibase 
kratio4=cpsoct(8+(kshift4/12))/ibase 
kratio5=cpsoct(8+(kshift5/12))/ibase 
kratio6=cpsoct(8+(kshift6/12))/ibase 

kjit1 jitter .002,.75,3.7
kjit2 jitter .001,.15,2.11
kjit3 jitter .0023,.1,1.4
kjit4 jitter .0025,.4,4.7
kjit5 jitter .0016,.6,3.8
kjit6 jitter .0019,.31,5.6

kratio1=kratio1+kjit1
kratio2=kratio2+kjit2
kratio3=kratio3+kjit3
kratio4=kratio4+kjit4
kratio5=kratio5+kjit5
kratio6=kratio6+kjit6

fftinL pvsanal aL,512,128,512,1 ;FFT analysis
fftinR pvsanal aR,512,128,512,1

fftT1L pvscale fftinL,kratio1 ;pitch scaling and resynthesis
fftT1R pvscale fftinR,kratio1
aT1L pvsynth fftT1L
aT1R pvsynth fftT1R

fftT2L pvscale fftinL,kratio2
fftT2R pvscale fftinR,kratio2
aT2L pvsynth fftT2L
aT2R pvsynth fftT2R

fftT3L pvscale fftinL,kratio3
fftT3R pvscale fftinR,kratio3
aT3L pvsynth fftT3L
aT3R pvsynth fftT3R

fftT4L pvscale fftinL,kratio4
fftT4R pvscale fftinR,kratio4
aT4L pvsynth fftT4L
aT4R pvsynth fftT4R

fftT5L pvscale fftinL,kratio5
fftT5R pvscale fftinR,kratio5
aT5L pvsynth fftT5L
aT5R pvsynth fftT5R

fftT6L pvscale fftinL,kratio6
fftT6R pvscale fftinR,kratio6
aT6L pvsynth fftT6L
aT6R pvsynth fftT6R

asumL=(aT1L*kharm1)+(aT2L*kharm2)+(aT3L*kharm3)+(aT4L*kharm4)+(aT5L*kharm5)+(aT6L*kharm6)
asumR=(aT1R*kharm1)+(aT2R*kharm2)+(aT3R*kharm3)+(aT4R*kharm4)+(aT5R*kharm5)+(aT6R*kharm6)
aL=(aL*(1-kharmmix))+(asumL*kharmmix)
aR=(aR*(1-kharmmix))+(asumR*kharmmix)
noharmon:

gaFXL=aL
gaFXR=aR

endin

instr 502   ;global chorus
kchmix chnget "chmix"
kchFB chnget "chFB"
kchdepth chnget "chdepth"
kchcps chnget "chcps"
kchrand chnget "chrand"
kchdel chnget "chdel"
achorusFBL init 0
achorusFBR init 0
afeedL=gaFXL+achorusFBL
afeedR=gaFXR+achorusFBR
kdepthrand=kchdepth*kchrand*.001
kchdel=kchdel*.001
kcpsrand=kchcps*kchrand
kchcps randomi kchcps-kcpsrand,kchcps+kcpsrand,kchcps
kchdepth randomi kchdepth-kdepthrand,kchdepth+kdepthrand,kchcps
kchdepth port kchdepth,.1
ardelL oscili kchdepth,kchcps,25
ardelR oscili kchdepth,kchcps,25,.25
ardel3 oscili kchdepth,kchcps,25,.5
ardel4 oscili kchdepth,kchcps,25,.75
ardelL=ardelL+(kchdepth*2.1+kchdel)
ardelR=ardelR+(kchdepth*2.1+kchdel)
ardel3=ardel3+(kchdepth*2.1+kchdel)
ardel4=ardel4+(kchdepth*2.1+kchdel)
amodL vdelay afeedL,ardelL,200
amodR vdelay afeedR,ardelR,200
amod3 vdelay afeedL*.33+afeedR*.66,ardel3,200
amod4 vdelay afeedR*.33+afeedL*.66,ardel4,200
achorusFBL=dcblock(((amodL*.6)+(amod4*.3)+(amod3*.15))*-kchFB)
achorusFBR=dcblock(((amodR*.6)+(amod3*.3)+(amod4*.15))*-kchFB)
gaChorL=((afeedL*.7+amodL)*kchmix)+((1-kchmix)*gaFXL)
gaChorR=((afeedR*.7+amodR)*kchmix)+((1-kchmix)*gaFXR)
endin

instr 505   ;global FB delay FX
aFBL init 0
aFBR init 0
kdel chnget "deltime"
kdel port kdel,.05
adel interp kdel*1000
kDelFB chnget "delFB"
aLdel vdelay gaChorL+aFBL,adel,5000
aRdel vdelay gaChorR+aFBR,adel,5000
aFBL=dcblock((aLdel*kDelFB)+gaChorL)
aFBR=dcblock((aRdel*kDelFB)+gaChorR)
gaDelL=aFBL
gaDelR=aFBR
endin

instr 510   ;global reverb, always on
krevmix chnget "revmix"
krevmix port krevmix,.05
krevFB chnget "revFB"
krevLP chnget "revLP"
aLrev,aRrev reverbsc gaDelL,gaDelR,krevFB,krevLP,sr,.075 ;don't need these to be global
outs	(gaDelL*(1-krevmix))+(aLrev*krevmix),(gaDelR*(1-krevmix))+(aRrev*krevmix)
endin

instr 600   ;clear global audio 
clear   gaSynL,gaSynR,gaDelL,gaDelR,gaFXL,gaFXR
endin

</CsInstruments>

<CsScore>
;causes Csound to run for about 7000 years...
f0 z
f25 0 8193 10 1   ;sine for FM and AM
f26 0 8193 7 -1 3500 -1 1193 1 3500 1   ;for distort opcode waveshaping
f27 0 16385 7 0 8192 1 8193 0   ;used to control flanger delay
f28 0 8193 10 1 0 .333 0 .2 0 .144 0 .1111 ;square wave
f29 0 8193 20 3 ;triangle envelope for harmonizer

i100 0 999999   ;MIDI sensing and controller mapping
i110 0 999999   ;MIDI mapping control for each plant
i120 0 999999
i130 0 999999
i140 0 999999
i160 0 999999
i180 0 999999
i200 0 999999
i210 0 999999
i220 0 999999
i230 0 999999
i240 0 999999
i250 0 999999
i260 0 999999
i280 0 999999
i290 0 999999
i300 0 999999
i400 0 999999       ;morphing functions 101 and 103
i401 0.001 999999   ;morphing functions 102 and 104
i500 0 999999       ;global FX
i502 0 999999
i505 0 999999       ;global delay
i510 0 999999       ;global reverb
i600 0 999999       ;global audio clear

</CsScore>
</CsoundSynthesizer>
